// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/IAeProcessEvent.java,v 1.9 2005/12/12 20:40:2
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel;

import javax.xml.namespace.QName;

/**
 * Interface for process events.
 */
public interface IAeProcessEvent extends IAeBaseProcessEvent
{
   /** Inactive activity process state. */
   public static final int INACTIVE = -1 ;
   /** Activity is ready to execute. */
   public static final int READY_TO_EXECUTE = 0 ;
   /** Activity is executing. */
   public static final int EXECUTING = 1 ;
   /** Activity finished executing with success. */
   public static final int EXECUTE_COMPLETE = 2 ;
   /** Activity finished executing with a fault. */
   public static final int EXECUTE_FAULT = 3 ;
   /** A link has been evaluated. */
   public static final int LINK_STATUS = 4 ;
   /** A bpel object is now a dead path meaning it will never execute. */
   public static final int DEAD_PATH_STATUS = 5 ;
   /** A bpel object has been terminated */
   public static final int TERMINATED = 6;
   /** A process has been migrated. */
   public static final int MIGRATED = 12;
   /** Activity is suspended. */
   public static final int SUSPENDED = 13;
   /** A bpel object is faulting */
   public static final int FAULTING = 14;

   /**
    * Returns the QName of the process this event was generated by.
    */
   public QName getQName();
}
