//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AeBaseDefNamespaceContext.java,v 1.1 2005/06/08 12:50:3
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import java.util.Set;

import org.activebpel.rt.bpel.IAeNamespaceContext;
import org.activebpel.rt.bpel.def.util.AeDefUtil;

/**
 * A concrete implementation of a namespace context that uses a bpel def object as the namespace info source.
 */
public class AeBaseDefNamespaceContext implements IAeNamespaceContext
{
   /** The base def. */
   private AeBaseDef mBaseDef;
   
   /**
    * Constructor.
    * 
    * @param aDef
    */
   public AeBaseDefNamespaceContext(AeBaseDef aDef)
   {
      setBaseDef(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.IAeNamespaceContext#resolveNamespaceToPrefixes(java.lang.String)
    */
   public Set resolveNamespaceToPrefixes(String aNamespace)
   {
      return AeDefUtil.getPrefixesForNamespace(getBaseDef(), aNamespace);
   }
   
   /**
    * @see org.activebpel.rt.bpel.IAeNamespaceContext#resolvePrefixToNamespace(java.lang.String)
    */
   public String resolvePrefixToNamespace(String aPrefix)
   {
      return AeDefUtil.translateNamespacePrefixToUri(getBaseDef(), aPrefix);
   }

   /**
    * @return Returns the baseDef.
    */
   protected AeBaseDef getBaseDef()
   {
      return mBaseDef;
   }

   /**
    * @param aBaseDef The baseDef to set.
    */
   protected void setBaseDef(AeBaseDef aBaseDef)
   {
      mBaseDef = aBaseDef;
   }
}
