// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AeCorrelationSetDef.java,v 1.10 2006/01/19 21:17:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;

import javax.xml.namespace.QName;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Definition for bpel correlation set.
 */
public class AeCorrelationSetDef extends AeNamedDef
{
   /** The properties of the correlation set. */
   private Collection mProperties;

   /**
    * Default constructor
    */
   public AeCorrelationSetDef()
   {
   }

   /**
    * Provides a list of correlation set properties for the user to iterate.
    * @return Iterator of property of object.
    */
   public Iterator getPropertiesList()
   {
      if (mProperties == null)
         return Collections.EMPTY_LIST.iterator();
      else
         return mProperties.iterator();
   }
   
   /**
    * Adds the given property to the list property list.
    * @param aProp property to be added
    */
   public void addProperty(QName aProperty)
   {
      if (mProperties == null)
         mProperties = new ArrayList();
         
      mProperties.add(aProperty);
   }
   
   /**
    * @param aVisitor 
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
   
   /**
    * Setter for the properties
    * @param aCollection
    */
   public void setProperties(Collection aCollection)
   {
      mProperties = aCollection;
   }

   /**
    * Getter for the properties
    */
   public Collection getProperties()
   {
      return mProperties;
   }

}
