// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AeFaultHandlersContainerDef.java,v 1.4 2004/07/08 13:09:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

import java.util.Iterator;

/**
 * Container class for fault handlers attached to a scope. 
 */
public class AeFaultHandlersContainerDef extends AeBaseContainer
{
   /** Default fault handler - <code>catchAll</code> */
   private AeDefaultFaultHandlerDef mDefaultFaultHandler;

   /**
    * Adds the fault handler to the collection
    * @param aDef
    */
   public void add(AeFaultHandlerDef aDef)
   {
      super.add(aDef);
   }

   /**
    * Gets an iterator for the faulthandlers
    */
   public Iterator getFaultHandlers()
   {
      return getValues();
   }

   /**
    * Getter for the default fault handler
    */
   public AeDefaultFaultHandlerDef getDefaultFaultHandler()
   {
      return mDefaultFaultHandler;
   }

   /**
    * Setter for the default fault handler
    * @param aDef
    */
   public void setDefaultFaultHandler(AeDefaultFaultHandlerDef aDef)
   {
      mDefaultFaultHandler = aDef;
   }

   /**
    * Tests for existence of a fault handler
    * @return true if there is one or if the default is not null
    */
   public boolean hasFaultHandlers()
   {
      return (getSize() > 0 || getDefaultFaultHandler() != null);
   }

   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
}
