// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AeImportDef.java,v 1.2 2004/07/08 13:09:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Definition for WSDL Import.
 */
public class AeImportDef extends AeNamedDef
{
   /** physical location of the WSDL document. */
   private String mLocation;
   
   /** the target namespace of the WSDL. */
   private String mNamespace;


   /**
    * Default constructor
    */
   public AeImportDef()
   {
   }

   /**
    * Accessor method to obtain WSDL document's location.
    * @return String WSDL location.
    */
   public final String getLocation()
   {
      return mLocation;
   }

   /**
    * Mutator method to set the WSDL document's location.
    * @param aLocation WSDL location.
    */
   public final void setLocation(String aLocation)
   {
      mLocation = aLocation;
   }

   /**
    * Accessor method to obtain the target namespace of the WSDL document. 
    * @return String the WSDL document's target namespace.
    */
   public final String getNamespace()
   {
      return mNamespace;
   }

   /**
    * Mutator method to set the WSDL document's target namespace.
    * @param aNamespace the WSDL document's target namespace.
    */
   public final void setNamespace(String aNamespace)
   {
      mNamespace = aNamespace;
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
}
