// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AePartnerDef.java,v 1.7 2004/08/10 19:09:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import java.util.ArrayList;
import java.util.Iterator;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Definition for bpel partner.
 */
public class AePartnerDef extends AeNamedDef
{
   /** List of strings which are the names of the associated partner links. */
   private ArrayList mPartnerLinks = new ArrayList();

   /**
    * Default constructor
    */
   public AePartnerDef()
   {
   }

   /**
    * Returns an iterator for the list of partnerLink names (String) associated
    * with this partner.
    */
   public Iterator getPartnerLinks()
   {
      return mPartnerLinks.iterator();
   }

   /**
    * Adds a partnerLink to the list associated with this partner.
    * @param aPartnerLink
    */
   public void addPartnerLink(String aPartnerLink)
   {
      mPartnerLinks.add(aPartnerLink);
   }

   /**
    * Removes a partnerLink from the list associated with this partner.
    * @param aPartnerLink
    */
   public void removePartnerLink(String aPartnerLink)
   {
      mPartnerLinks.remove(aPartnerLink);
   }

   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
}
