// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/AePartnerLinkDef.java,v 1.8 2005/02/10 16:34:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import javax.xml.namespace.QName;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;
import org.activebpel.rt.wsdl.def.IAePartnerLinkType;

/**
 * Definition for bpel partner link.
 */
public class AePartnerLinkDef extends AeNamedDef
{
   private QName mPartnerLinkTypeName;
   private String mMyRole;
   private String mPartnerRole;
   private IAePartnerLinkType mPartnerLinkType;

   /**
    * Default constructor
    */
   public AePartnerLinkDef()
   {
   }

   /**
    * @return Returns the partnerLinkType.
    */
   public IAePartnerLinkType getPartnerLinkType()
   {
      return mPartnerLinkType;
   }

   /**
    * @param aPartnerLinkType The partnerLinkType to set.
    */
   public void setPartnerLinkType(IAePartnerLinkType aPartnerLinkType)
   {
      mPartnerLinkType = aPartnerLinkType;
   }
   
   /**
    * Accessor method to obtain the Partner Link Type for this partner.
    * 
    * @return partner link type of the partner
    */
   public final QName getPartnerLinkTypeName()
   {
      return mPartnerLinkTypeName;
   }

   /**
    * Mutator method to set the Partner Link Type for this partner.
    * 
    * @param aPartnerLinkType the Partner Link Type for this partner
    */
   public final void setPartnerLinkTypeName(QName aPartnerLinkType)
   {
      mPartnerLinkTypeName = aPartnerLinkType;
   }

   /**
    * Accessor method to obtain my role for this partner link.
    * 
    * @return my role for this partner link
    */
   public final String getMyRole()
   {
      return mMyRole;
   }

   /**
    * Mutator method to set myRole for this partner link.
    * 
    * @param aMyRole my role for this partner link
    */
   public final void setMyRole(String aMyRole)
   {
      mMyRole = aMyRole;
   }

   /**
    * Accessor method to obtain the partner role for this partner link.
    * 
    * @return partner role for this partner link
    */
   public final String getPartnerRole()
   {
      return mPartnerRole;
   }

   /**
    * Mutator method to set the partner role for this partner link.
    * 
    * @param aPartnerRole partner role for this partner link.
    */
   public final void setPartnerRole(String aPartnerRole)
   {
      mPartnerRole = aPartnerRole;
   }
   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
}
