// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/IAeBPELConstants.java,v 1.16 2006/01/11 21:01:0
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def;

import org.activebpel.rt.IAeConstants;

/**
 * Contains the list of BPEL Constants.
 */
public interface IAeBPELConstants extends IAeConstants
{
   // @todo set the active endpoints namespace URI to proper date during release
   /** Active Endpoints namespace declaration. Used for system faults */
   public static final String AE_NAMESPACE_URI = "http://www.active-endpoints.com/2004/06/bpel/extensions/"; //$NON-NLS-1$
   /** BPEL namespace declaration */
   public static final String BPWS_NAMESPACE_URI = "http://schemas.xmlsoap.org/ws/2003/03/business-process/"; //$NON-NLS-1$
   /** BPEL extensions namespace declaration. */
   public static final String ABX_2_0_NAMESPACE_URI = "http://www.activebpel.org/2.0/bpel/extension"; //$NON-NLS-1$
   /** BPEL extensions namespace declaration. Used for functions */
   public static final String ABX_FUNCTIONS_NAMESPACE_URI = "http://www.activebpel.org/bpel/extension"; //$NON-NLS-1$
   /** Default Schema NS */
   public static final String DEFAULT_SCHEMA_NS = "http://www.w3.org/2001/XMLSchema"; //$NON-NLS-1$

   public static final String ATTR_NO  = "no"; //$NON-NLS-1$
   public static final String ATTR_YES = "yes"; //$NON-NLS-1$

   // activity name constants
   public static final String TAG_ASSIGN = "assign"; //$NON-NLS-1$
   public static final String TAG_EMPTY = "empty"; //$NON-NLS-1$
   public static final String TAG_FLOW  = "flow"; //$NON-NLS-1$
   public static final String TAG_INVOKE = "invoke"; //$NON-NLS-1$
   public static final String TAG_PICK = "pick"; //$NON-NLS-1$
   public static final String TAG_REPLY = "reply"; //$NON-NLS-1$
   public static final String TAG_RECEIVE = "receive"; //$NON-NLS-1$
   public static final String TAG_SEQUENCE = "sequence"; //$NON-NLS-1$
   public static final String TAG_SWITCH = "switch"; //$NON-NLS-1$
   public static final String TAG_TERMINATE = "terminate"; //$NON-NLS-1$
   public static final String TAG_THROW = "throw"; //$NON-NLS-1$
   public static final String TAG_WAIT = "wait"; //$NON-NLS-1$
   public static final String TAG_WHILE = "while"; //$NON-NLS-1$
   public static final String TAG_CONTINUE = "continue"; //$NON-NLS-1$
   public static final String TAG_BREAK = "break"; //$NON-NLS-1$
   public static final String TAG_FOREACH = "forEach"; //$NON-NLS-1$
   public static final String TAG_SUSPEND = "suspend"; //$NON-NLS-1$
   public static final String TAG_FOREACH_BRANCHES = "branches"; //$NON-NLS-1$
   public static final String TAG_FOREACH_COMPLETION_CONDITION = "completionCondition"; //$NON-NLS-1$

   public static final String TAG_PROCESS = "process"; //$NON-NLS-1$
   public static final String TAG_TARGET_NAMESPACE = "targetNamespace"; //$NON-NLS-1$
   public static final String TAG_QUERY_LANGUAGE = "queryLanguage"; //$NON-NLS-1$
   public static final String TAG_EXPRESSION_LANGUAGE = "expressionLanguage"; //$NON-NLS-1$
   public static final String TAG_SUPPRESS_JOIN_FAILURE = "suppressJoinFailure"; //$NON-NLS-1$
   public static final String TAG_ENABLE_INSTANCE_COMPENSATION = "enableInstanceCompensation"; //$NON-NLS-1$
   public static final String TAG_ABSTRACT_PROCESS = "abstractProcess"; //$NON-NLS-1$
   
   public static final String TAG_PARTNER_LINK = "partnerLink"; //$NON-NLS-1$
   public static final String TAG_PARTNER_LINK_TYPE = "partnerLinkType"; //$NON-NLS-1$
   public static final String TAG_MY_ROLE = "myRole"; //$NON-NLS-1$
   public static final String TAG_PARTNER_ROLE = "partnerRole"; //$NON-NLS-1$
   
   public static final String TAG_PARTNERS = "partners"; //$NON-NLS-1$
   public static final String TAG_PARTNER = "partner"; //$NON-NLS-1$
   
   public static final String TAG_VARIABLE = "variable"; //$NON-NLS-1$
   public static final String TAG_MESSAGE_TYPE = "messageType"; //$NON-NLS-1$
   public static final String TAG_TYPE = "type"; //$NON-NLS-1$
   public static final String TAG_ELEMENT = "element"; //$NON-NLS-1$
   
   public static final String TAG_CORRELATION = "correlation"; //$NON-NLS-1$

   public static final String TAG_CORRELATIONS = "correlations"; //$NON-NLS-1$
   public static final String TAG_CORRELATION_SETS = "correlationSets"; //$NON-NLS-1$
   public static final String TAG_CORRELATION_SET = "correlationSet"; //$NON-NLS-1$
   public static final String TAG_FAULT_HANDLERS = "faultHandlers"; //$NON-NLS-1$
   public static final String TAG_EVENT_HANDLERS = "eventHandlers"; //$NON-NLS-1$
   public static final String TAG_VARIABLES = "variables"; //$NON-NLS-1$
   public static final String TAG_PARTNER_LINKS = "partnerLinks"; //$NON-NLS-1$

   public static final String TAG_PROPERTIES = "properties"; //$NON-NLS-1$
   

   public static final String TAG_ON_MESSAGE = "onMessage"; //$NON-NLS-1$
   public static final String TAG_ON_ALARM = "onAlarm"; //$NON-NLS-1$
   public static final String TAG_FAULT_VARIABLE = "faultVariable"; //$NON-NLS-1$
   public static final String TAG_FAULT_NAME = "faultName"; //$NON-NLS-1$
   
   public static final String TAG_MESSAGE_EXCHANGE = "messageExchange"; //$NON-NLS-1$

   public static final String TAG_MODEL_VERSION = "modelVersion"; //$NON-NLS-1$


   // standard attributes names of the copy definition
   public static final String TAG_SET        = "set"; //$NON-NLS-1$
   public static final String TAG_INITIATE   = "initiate"; //$NON-NLS-1$
   public static final String TAG_PATTERN    = "pattern"; //$NON-NLS-1$



   public static final String TAG_CREATE_INSTANCE = "createInstance"; //$NON-NLS-1$


   // standard attributes names of the throw activity definition
   public static final String TAG_VARIABLE_ACCESS_SERIALIZABLE = "variableAccessSerializable"; //$NON-NLS-1$



   public static final String TAG_CATCH = "catch"; //$NON-NLS-1$
   public static final String TAG_CATCH_ALL = "catchAll"; //$NON-NLS-1$
   public static final String TAG_COMPENSATION_HANDLER = "compensationHandler"; //$NON-NLS-1$
   public static final String TAG_INPUT_VARIABLE = "inputVariable"; //$NON-NLS-1$
   public static final String TAG_OUTPUT_VARIABLE = "outputVariable"; //$NON-NLS-1$
   public static final String TAG_CASE = "case"; //$NON-NLS-1$
   public static final String TAG_OTHERWISE = "otherwise"; //$NON-NLS-1$
   public static final String TAG_CONDITION = "condition"; //$NON-NLS-1$

   public static final String TAG_FOR   = "for"; //$NON-NLS-1$
   public static final String TAG_UNTIL = "until"; //$NON-NLS-1$
   
   public static final String TAG_FOREACH_COUNTERNAME = "counterName"; //$NON-NLS-1$
   public static final String TAG_FOREACH_PARALLEL = "parallel"; //$NON-NLS-1$
   public static final String TAG_FOREACH_STARTCOUNTER = "startCounterValue"; //$NON-NLS-1$
   public static final String TAG_FOREACH_FINALCOUNTER = "finalCounterValue"; //$NON-NLS-1$
   public static final String TAG_FOREACH_BRANCH_COUNTCOMPLETED = "countCompletedBranchesOnly"; //$NON-NLS-1$
   
   public static final String TAG_SCOPE_MESSAGEEXCHANGES = "messageExchanges"; //$NON-NLS-1$
   public static final String TAG_SCOPE_MESSAGEEXCHANGE  = "messageExchange"; //$NON-NLS-1$


  // attributes tag names of a definition
   public static final String TAG_LINK_NAME = "linkName"; //$NON-NLS-1$

   public static final String TAG_COPY = "copy"; //$NON-NLS-1$

  // standard element names of the activity definition
   public static final String TAG_TARGET = "target"; //$NON-NLS-1$
   public static final String TAG_SOURCE = "source"; //$NON-NLS-1$

   // attributes tag names of a definition
   public static final String TAG_TRANSITION_CONDITION = "transitionCondition"; //$NON-NLS-1$

   // standard element names of the copy definition
   public static final String TAG_FROM = "from"; //$NON-NLS-1$
   public static final String TAG_TO = "to"; //$NON-NLS-1$

   // standard attributes names of the activity definition
   public static final String TAG_PART = "part"; //$NON-NLS-1$
   public static final String TAG_QUERY = "query"; //$NON-NLS-1$
   public static final String TAG_ENDPOINT_REFERENCE = "endpointReference"; //$NON-NLS-1$
   public static final String TAG_PROPERTY = "property"; //$NON-NLS-1$
   public static final String TAG_EXPRESSION = "expression"; //$NON-NLS-1$
   public static final String TAG_OPAQUE = "opaque"; //$NON-NLS-1$

   public static final String TAG_SCOPE = "scope"; //$NON-NLS-1$

   public static final String TAG_JOIN_CONDITION   = "joinCondition"; //$NON-NLS-1$
   public static final String TAG_SUPPRESS_FAILURE = "suppressJoinFailure"; //$NON-NLS-1$
   public static final String TAG_NAME = "name"; //$NON-NLS-1$

   public static final String TAG_COMPENSATE = "compensate"; //$NON-NLS-1$

   public static final String TAG_LINKS = "links"; //$NON-NLS-1$
   public static final String TAG_LINK  = "link"; //$NON-NLS-1$

   // standard attributes names of the activity definition
   public static final String TAG_PORT_TYPE = "portType"; //$NON-NLS-1$
   public static final String TAG_OPERATION = "operation"; //$NON-NLS-1$


}
