// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/AeActivityReceiveDef.java,v 1.11 2005/12/08 23:33:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity;

import org.activebpel.rt.bpel.def.AeActivityCreateInstanceBaseDef;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Definition for bpel receive activity.
 */
public class AeActivityReceiveDef extends AeActivityCreateInstanceBaseDef
implements IAeReceiveActivityDef
{
   // standard attributes of the process
   private String mVariable;
   /**  indicates the one-way attribute flag. */
   private boolean mOneWay;
   /** used to match a receive to its reply */
   private String mMessageExchange;

   // standard element names of the activity definition
   public static final String TAG_RECEIVE = "receive"; //$NON-NLS-1$

   /**
    * Default constructor
    */
   public AeActivityReceiveDef()
   {
   }

   /**
    * Accessor method to set the container for the receive element.
    * 
    * @return name of variable
    */
   public final String getVariable()
   {
      return mVariable;
   }

   /**
    * Mutator method to set the variable for the receive element.
    * 
    * @param aVariable name of variable
    */
   public final void setVariable(String aVariable)
   {
      mVariable = aVariable;
   }

   /**
    * Accessor method to obtain the oneWay flag.
    */
   public final boolean isOneWay()
   {
      return mOneWay;
   }

   /**
    * Mutator method to set the one way flag for the activity.
    * 
    * @param aOneWay boolean flag indicating if the instance should be one way.
    */
   public final void setOneWay(boolean aOneWay)
   {
      mOneWay = aOneWay;
   }

   /**
    * @see org.activebpel.rt.bpel.def.AeActivityDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
   
   /**
    * @return Returns the messageExchange.
    */
   public String getMessageExchange()
   {
      return mMessageExchange;
   }

   /**
    * @param aMessageExchange The messageExchange to set.
    */
   public void setMessageExchange(String aMessageExchange)
   {
      mMessageExchange = aMessageExchange;
   }
}
