// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/AeActivityReplyDef.java,v 1.7 2005/10/17 19:44:2
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity;

import javax.xml.namespace.QName;

import org.activebpel.rt.bpel.def.AeActivityPartnerLinkBaseDef;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Definition for bpel reply activity.
 */
public class AeActivityReplyDef extends AeActivityPartnerLinkBaseDef
{
   // standard attributes of the process
   private String mVariable;
   private QName mFaultName;
   private String mMessageExchange;

   /**
    * Default constructor
    */
   public AeActivityReplyDef()
   {
   }

   /**
    * Accessor method to obtain the name of the variable associated with this activity.
    * 
    * @return name of the variable
    */
   public final String getVariable()
   {
      return mVariable;
   }

   /**
    * Mutator method to set the name of the variable for this activity.
    * 
    * @param aVariable name of variable
    */
   public final void setVariable(String aVariable)
   {
      mVariable = aVariable;
   }

   /**
    * Accessor method to obtain the name of the fault associated with this activity.
    * 
    * @return name of the fault
    */
   public final QName getFaultName()
   {
      return mFaultName;
   }

   /**
    * Mutator method to set the name of the fault for this activity.
    * 
    * @param aFaultName name of fault
    */
   public final void setFaultName(QName aFaultName)
   {
      mFaultName = aFaultName;
   }

   /**
    * @see org.activebpel.rt.bpel.def.AeActivityDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }

   /**
    * @return Returns the messageExchange.
    */
   public String getMessageExchange()
   {
      return mMessageExchange;
   }

   /**
    * @param aMessageExchange The messageExchange to set.
    */
   public void setMessageExchange(String aMessageExchange)
   {
      mMessageExchange = aMessageExchange;
   }
}
