// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeAssignCopyDef.java,v 1.7 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * Holds individual copy operations of an assign activity
 */
public class AeAssignCopyDef extends AeBaseDef
{
   // standard elements of the activity definition
   private AeAssignFromDef mFrom;
   private AeAssignToDef mTo;

   /**
    * Default constructor
    */
   public AeAssignCopyDef()
   {
   }

   /**
    * Accessor method to obtain the From assignment part of the Copy activity.
    * 
    * @return the From assignment object
    */
   public final AeAssignFromDef getFrom()
   {
      return mFrom;
   }

   /**
    * Mutator method to set the From assignment part of the Copy activity.
    * 
    * @param aFrom the From part of the Copy activity
    */
   public final void setFrom(AeAssignFromDef aFrom)
   {
      mFrom = aFrom;
   }

   /**
    * Accessor method to obtain the To assignment part of the Copy activity.
    * 
    * @return the To assignment object
    */
   public final AeAssignToDef getTo()
   {
      return mTo;
   }

   /**
    * Mutator method to set the To assignment part of the Copy activity.
    * 
    * @param aFrom the To part of the Copy activity
    */
   public final void setTo(AeAssignToDef aTo)
   {
      mTo = aTo;
   }
   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
   
}
