// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeAssignVarDef.java,v 1.9 2005/10/12 19:26:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.AeBaseDef;

/**
 * Assign activity support class, variables for copying information. This is an
 * abstract class so we can subclass for the explicit <code>from</code>
 * and <code>to</code> copy operations.
 */
abstract public class AeAssignVarDef extends AeBaseDef
{
   private String mVariable;
   private String mPart;
   private String mQuery;
   private String mProperty;
   private String mPartnerLink;

   /**
    * Default constructor
    */
   public AeAssignVarDef()
   {
   }

   /**
    * Return the variable value for the operation, null if none.
    */
   public final String getVariable()
   {
      return mVariable;
   }

   /**
    * Set the variable value for the operation.
    */
   public final void setVariable(String aVariable)
   {
      mVariable = aVariable;
   }

   /**
    * Accessor method to obtain the property for the object.
    * 
    * @return name of the property for the object
    */
   public final String getProperty()
   {
      return mProperty;
   }

   /**
    * Mutator method to set the property for the object.
    * 
    * @param aProperty the property value to be set
    */
   public final void setProperty(String aProperty)
   {
      mProperty = aProperty;
   }

   /**
    * Accessor method to obtain the part name for the object.
    * 
    * @return name of the part name for the object
    */
   public final String getPart()
   {
      return mPart;
   }

   /**
    * Mutator method to set the part for the object.
    * 
    * @param aPart the part value to be set
    */
   public final void setPart(String aPart)
   {
      mPart = aPart;
   }

   /**
    * Accessor method to obtain the query string for the object.
    * 
    * @return query string for the object
    */
   public final String getQuery()
   {
      return mQuery;
   }

   /**
    * Mutator method to set the query value for the object.
    * 
    * @param aQuery the query value to be set
    */
   public final void setQuery(String aQuery)
   {
      mQuery = aQuery;
   }

   /**
    * Return the partner link associated with this operation, null if none.
    */
   public final String getPartnerLink()
   {
      return mPartnerLink;
   }

   /**
    * Sets the partner link associated with this operation, null if none.
    */
   public final void setPartnerLink(String aPartnerLink)
   {
      mPartnerLink = aPartnerLink;
   }
}
