// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeLinkContainerDef.java,v 1.4 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.AeBaseContainer;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

import java.util.Iterator;

/**
 * Container for the links within a Flow. Using this container as opposed to 
 * a collection so it can be visited.
 */
public class AeLinkContainerDef extends AeBaseContainer
{
   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
   
   /**
    * Adds a link to the collection.
    * @param aDef
    */
   public void add(AeLinkDef aDef)
   {
      super.add(aDef);
   }
   
   /**
    * Removes the link from the collection.
    * 
    * @param aDef
    * @return false if not found within collection
    */
   public boolean remove(AeLinkDef aDef)
   {
      return super.removeByValue(aDef);
   }
   
   /**
    * Gets the iterator for the collection of links.
    */
   public Iterator getLinks()
   {
      return getValues();
   }
}
