// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeOnAlarmDef.java,v 1.7 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.AeActivityDef;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.IAeSingleActivityContainerDef;
import org.activebpel.rt.bpel.def.activity.IAeTimedDef;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;


/** The onAlarm element used within the Pick activity */
public class AeOnAlarmDef extends AeBaseDef implements IAeSingleActivityContainerDef, IAeTimedDef
{
   // standard attributes of the copy
   private String mFor;
   private String mUntil;

   // standard elements of the activity definition
   private AeActivityDef mActivity;

   /**
    * Default constructor
    */
   public AeOnAlarmDef()
   {
   }

   /**
    * Accessor method to obtain the boolean expression of the For condition.
    * 
    * @return expression of For condition
    */
   public final String getFor()
   {
      return mFor;
   }

   /**
    * Mutator method to set the boolean expression of the For condition.
    * 
    * @param aFor boolean expression for For condition 
    */
   public final void setFor(String aFor)
   {
      mFor = aFor;
   }
   
   /**
    * Accessor method to obtain the boolean expression of the Until condition.
    * 
    * @return expression of Until condition
    */
   public final String getUntil()
   {
      return mUntil;
   }

   /**
    * Mutator method to set the boolean expression of the Until condition.
    * 
    * @param aUntil boolean expression for Until condition 
    */
   public final void setUntil(String aUntil)
   {
      mUntil = aUntil;
   }

   /**
    * Accessor method to get the activity associated with the while loop.
    * 
    * @return activity associated with while loop
    */
   public final AeActivityDef getActivity()
   {
      return mActivity;
   }

   /**
    * Mutator method to set the activity associated with the while loop.
    * 
    * @param aActivity the activity to be set
    */
   public final void setActivity(AeActivityDef aActivity)
   {
      mActivity = aActivity;
   }
   
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }

}
