// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeOtherwiseDef.java,v 1.7 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.AeActivityDef;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.IAeSingleActivityContainerDef;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/**
 * The 'otherwise' choice in a switch statement. Broken out into its own class
 * here to make visiting it more explicit.
 * 
 */
public class AeOtherwiseDef extends AeBaseDef implements IAeSingleActivityContainerDef
{
   /** The child activity */
   protected AeActivityDef mActivity;
   

   /**
    * No-arg ctor. 
    */
   public AeOtherwiseDef()
   {
   }

   /**
    * @see org.activebpel.rt.bpel.def.AeBaseDef#accept(org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
    */
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }

   /**
    * Accessor method to get the activity associated with the while loop.
    * 
    * @return activity associated with while loop
    */
   public final AeActivityDef getActivity()
   {
      return mActivity;
   }

   /**
    * Mutator method to set the activity associated with the while loop.
    * 
    * @param aActivity the activity to be set
    */
   public final void setActivity(AeActivityDef aActivity)
   {
      mActivity = aActivity;
   }
}
