// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/activity/support/AeSwitchCaseDef.java,v 1.5 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.activity.support;

import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;

/** Holds individual case statements of a switch activity */
public class AeSwitchCaseDef extends AeOtherwiseDef
{
   // standard attributes of the switch
   private String mCondition;

   /**
    * Default constructor
    */
   public AeSwitchCaseDef()
   {
   }

   /**
    * Accessor method to obtain the boolean expression for the case condition.
    * 
    * @return boolean expression for the case condition
    */
   public final String getCondition()
   {
      return mCondition;
   }

   /**
    * Mutator method to set the boolean expression for the case condition.
    * 
    * @param aCondition boolean expression 
    */
   public final void setCondition(String aCondition)
   {
      mCondition = aCondition;
   }
   
   public void accept(IAeDefVisitor aVisitor)
   {
      aVisitor.visit(this);
   }
   
}

