//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/expr/xpath/AeXPathParseResult.java,v 1.2 2005/06/14 17:06:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.expr.xpath;

import java.util.LinkedHashSet;
import java.util.Set;

import org.activebpel.rt.bpel.def.expr.AeAbstractExpressionParseResult;
import org.activebpel.rt.bpel.def.expr.IAeExpressionParserContext;

/**
 * A concrete implementation of a parse result for the xpath language.
 */
public class AeXPathParseResult extends AeAbstractExpressionParseResult
{
   /** The parse handler used during parsing. */
   private AeXPathParseHandler mHandler;

   /**
    * Creates the xpath parse result.
    * 
    * @param aExpression
    * @param aHandler
    * @param aParserContext
    */
   public AeXPathParseResult(String aExpression, AeXPathParseHandler aHandler, IAeExpressionParserContext aParserContext)
   {
      super(aExpression, aParserContext);
      setHandler(aHandler);
      setErrors(aHandler.getErrors());
   }

   /**
    * @see org.activebpel.rt.bpel.def.expr.IAeExpressionParseResult#getFunctions()
    */
   public Set getFunctions()
   {
      return new LinkedHashSet(getHandler().getFunctions());
   }

   /**
    * @return Returns the handler.
    */
   public AeXPathParseHandler getHandler()
   {
      return mHandler;
   }

   /**
    * @param aHandler The handler to set.
    */
   protected void setHandler(AeXPathParseHandler aHandler)
   {
      mHandler = aHandler;
   }
}
