// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/AeBpelFactoryImpl.java,v 1.2 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io;

import org.activebpel.rt.bpel.def.io.readers.AeBpelReaderImpl;
import org.activebpel.rt.bpel.def.io.writers.AeBpelWriterImpl;

/**
 * Default implementation for providing serializers and 
 * deserialzers. 
 */
public class AeBpelFactoryImpl extends AeBpelFactory
{

   /**
    * @see org.activebpel.rt.bpel.def.io.AeBpelFactory#createBpelReader()
    * @return new AeBpelReaderImpl 
    */
   public IAeBpelReader createBpelReader()
   {
      AeBpelReaderImpl reader = new AeBpelReaderImpl();
      return reader;
   }

   /**
    * @see org.activebpel.rt.bpel.def.io.AeBpelFactory#createBpelWriter()
    * @return new AeBPelWriterImpl
    */
   protected IAeBpelWriter createBpelWriter()
   {
      AeBpelWriterImpl writer = new AeBpelWriterImpl();
      return writer;
   }
}
