// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/IAeBpelClassConstants.java,v 1.6 2006/01/11 21:01:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io;

import org.activebpel.rt.bpel.def.AeCorrelationContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetDef;
import org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeEventHandlersDef;
import org.activebpel.rt.bpel.def.AeFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef;
import org.activebpel.rt.bpel.def.AeMessageExchangesDef;
import org.activebpel.rt.bpel.def.AePartnerDef;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.bpel.def.AePartnerLinksContainerDef;
import org.activebpel.rt.bpel.def.AePartnersContainerDef;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef;
import org.activebpel.rt.bpel.def.AeScopeDef;
import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.AeVariablesContainerDef;
import org.activebpel.rt.bpel.def.activity.AeActivityAssignDef;
import org.activebpel.rt.bpel.def.activity.AeActivityBreakDef;
import org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityContinueDef;
import org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityFlowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;
import org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef;
import org.activebpel.rt.bpel.def.activity.AeActivityPickDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReplyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityScopeDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef;
import org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityThrowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWaitDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWhileDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignToDef;
import org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;
import org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef;
import org.activebpel.rt.bpel.def.activity.support.AeSourceDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.def.activity.support.AeTargetDef;

/**
 * Defines all of the class constants used by IAeBpelDefWriters, 
 * IAeBpelDefReaders, and the corresponding registries.
 * <br />
 * This is used in place of Class.forName where we are constrained by
 * current obfuscation.
 */
public interface IAeBpelClassConstants
{

   public static final Class ASSIGN_COPY_CLASS             = AeAssignCopyDef.class;
   public static final Class ASSIGN_TO_CLASS               = AeAssignToDef.class;
   public static final Class ASSIGN_FROM_CLASS             = AeAssignFromDef.class;
   public static final Class CASE_CLASS                    = AeSwitchCaseDef.class;
   public static final Class CORRELATION_CLASS             = AeCorrelationDef.class;
   public static final Class CORRELATION_CONTAINER_CLASS   = AeCorrelationContainerDef.class;
   public static final Class CORRELATION_SET_CLASS         = AeCorrelationSetDef.class;
   public static final Class CORRELATION_SETS_CLASS        = AeCorrelationSetContainerDef.class;
   public static final Class DEFAULT_FAULT_HANDLER_CLASS   = AeDefaultFaultHandlerDef.class;
   public static final Class EVENT_HANDLERS_CLASS          = AeEventHandlersDef.class;
   public static final Class FAULT_HANDLER_CLASS           = AeFaultHandlerDef.class;
   public static final Class FAULT_HANDLER_CONTAINER_CLASS = AeFaultHandlersContainerDef.class;
   public static final Class LINK_CLASS                    = AeLinkDef.class;
   public static final Class LINKS_CONTAINER_CLASS         = AeLinkContainerDef.class;
   public static final Class MESSAGE_EXCHANGES_CLASS       = AeMessageExchangesDef.class;
   public static final Class ON_ALARM_CLASS                = AeOnAlarmDef.class;
   public static final Class ON_MESSAGE_CLASS              = AeOnMessageDef.class;
   public static final Class OTHERWISE_CLASS               = AeOtherwiseDef.class;
   public static final Class PARTNER_CLASS                 = AePartnerDef.class;
   public static final Class PARTNER_CONTAINER_CLASS       = AePartnersContainerDef.class;
   public static final Class PARTNER_LINK_CLASS            = AePartnerLinkDef.class;
   public static final Class PARNTER_LINKS_CONTAINER_CLASS = AePartnerLinksContainerDef.class;
   public static final Class PROCESS_CLASS                 = AeProcessDef.class;
   public static final Class SCOPE_CLASS                   = AeScopeDef.class;
   public static final Class SCOPE_COMPENSATOR_CONTAINER_CLASS = AeScopeCompensatorContainerDef.class;
   public static final Class SOURCE_CLASS                  = AeSourceDef.class;
   public static final Class TARGET_CLASS                  = AeTargetDef.class;
   public static final Class VARIABLE_CLASS                = AeVariableDef.class;
   public static final Class VARIABLE_CONTAINER_CLASS      = AeVariablesContainerDef.class;

   public static final Class ACTIVITY_ASSIGN_CLASS     = AeActivityAssignDef.class;
   public static final Class ACTIVITY_COMPENSATE_CLASS = AeActivityCompensateDef.class;
   public static final Class ACTIVITY_EMPTY_CLASS      = AeActivityEmptyDef.class;
   public static final Class ACTIVITY_FLOW_CLASS       = AeActivityFlowDef.class;
   public static final Class ACTIVITY_INVOKE_CLASS     = AeActivityInvokeDef.class;
   public static final Class ACTIVITY_PICK_CLASS       = AeActivityPickDef.class;
   public static final Class ACTIVITY_SCOPE_CLASS      = AeActivityScopeDef.class;
   public static final Class ACTIVITY_SEQUENCE_CLASS   = AeActivitySequenceDef.class;
   public static final Class ACTIVITY_SWITCH_CLASS     = AeActivitySwitchDef.class;
   public static final Class ACTIVITY_TERMINATE_CLASS  = AeActivityTerminateDef.class;
   public static final Class ACTIVITY_THROW_CLASS      = AeActivityThrowDef.class;
   public static final Class ACTIVITY_REPLY_CLASS      = AeActivityReplyDef.class;
   public static final Class ACTIVITY_RECEIVE_CLASS    = AeActivityReceiveDef.class;
   public static final Class ACTIVITY_WAIT_CLASS       = AeActivityWaitDef.class;
   public static final Class ACTIVITY_WHILE_CLASS      = AeActivityWhileDef.class;
   public static final Class ACTIVITY_CONTINUE_CLASS   = AeActivityContinueDef.class;
   public static final Class ACTIVITY_BREAK_CLASS      = AeActivityBreakDef.class;
   public static final Class ACTIVITY_FOREACH_CLASS    = AeActivityForEachDef.class;
   public static final Class ACTIVITY_FOREACH_START    = AeForEachStartDef.class;
   public static final Class ACTIVITY_FOREACH_FINAL    = AeForEachFinalDef.class;
   public static final Class ACTIVITY_FOREACH_COMPLETION_CONDITION = AeForEachCompletionConditionDef.class;
   public static final Class ACTIVITY_FOREACH_BRANCH   = AeForEachBranchesDef.class;
   public static final Class ACTIVITY_SUSPEND_CLASS    = AeActivitySuspendDef.class;
}
