// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/IAeBpelWriter.java,v 1.2 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.io.registry.IAeBpelRegistry;
import org.activebpel.rt.bpel.def.io.registry.IAeExtensionRegistry;

import org.w3c.dom.Document;

/**
 * Interface for working with BPEL serializers.
 */
public interface IAeBpelWriter
{

   /**
    * Serializes the <code>AeProcessDef</code> to it's xml
    * representation.
    * @param aProcessDef
    * @return BPEL dom
    * @throws AeBpelException
    */
   public Document writeBPEL( AeProcessDef aProcessDef )
   throws AeBusinessProcessException;
   
   /**
    * Mutator for setting the bpel registry.  AeBpelFactory
    * is responsible for setting a default value.
    * @param aRegistry
    */
   public void setBpelRegistry( IAeBpelRegistry aRegistry );
   
   /**
    * Mutator for setting an extension registry on the 
    * current writer.
    * <br/>
    * Setting this value to null will cause an exception
    * to be thrown in the writer if it encounters any
    * AeDef objects that contain extension elements.
    * @param aRegistry
    */
   public void setExtensionRegistry( IAeExtensionRegistry aRegistry );

}
