// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/ext/AeDefaultExtensionElementIO.java,v 1.2 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.ext;

import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.io.AeCommentIO;

import javax.xml.namespace.QName;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 * Default serializer/deserializer for all extensions elements. 
 */
public class AeDefaultExtensionElementIO implements IAeExtensionReader, IAeExtensionWriter
{
   /**
    * Creates an <code>AeDefaultExtensionElement</code>.
    * @see org.activebpel.rt.bpel.def.io.ext.IAeExtensionReader#read(org.activebpel.rt.bpel.def.AeBaseDef, org.w3c.dom.Element)
    */
   public IAeExtensionElement read(AeBaseDef aParent, Element aExtElement)
   {
      AeDefaultExtensionElement extElement = new AeDefaultExtensionElement();
      QName qName = new QName( aExtElement.getNamespaceURI(), aExtElement.getLocalName() );
      extElement.setElementQName( qName );
      extElement.setExtensionElement( aExtElement );
      return extElement;
   }
   

   /**
    * Serializes the IAeExtensionElement.
    * <br />
    * Expects an instance of <code>AeDefaultExtensionElement</code>.
    * @see org.activebpel.rt.bpel.def.io.ext.IAeExtensionWriter#write(org.w3c.dom.Element, org.activebpel.rt.bpel.def.io.ext.IAeExtensionElement)
    */
   public void write(Element aParentElement, IAeExtensionElement aExtElement)
   {
      AeDefaultExtensionElement extElement = (AeDefaultExtensionElement)aExtElement;
      Document bpelDoc = aParentElement.getOwnerDocument();
      // copy the existing node set over
      Node extNode = bpelDoc.importNode( extElement.getExtensionElement(), true );
      aParentElement.appendChild( extNode );
      AeCommentIO.writeFormattedComments(extNode,extElement.getComments());
   }
}
