// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/ext/IAeExtensionReader.java,v 1.4 2005/10/17 19:44:3
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.ext;

import org.activebpel.rt.bpel.def.AeBaseDef;

import org.w3c.dom.Element;

/**
 *  Interface for extension BPEL element deserializers.
 */
public interface IAeExtensionReader
{
   /** impl of extension reader that returns null for the extension element. */
   public static final IAeExtensionReader NULL_READER = new IAeExtensionReader()
   {
      public IAeExtensionElement read( AeBaseDef aParent, Element aExtElement )
      {
         return null;
      }
   };
   
   /**
    * Deserialize the current extension element.
    * @param aParent the parent def object
    * @param aExtElement the extension element
    * @return IAeExtensionElement impl
    */
   public IAeExtensionElement read( AeBaseDef aParent, Element aExtElement );

}
