// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/readers/def/AeReaderVisitor.java,v 1.23 2006/02/01 22:44:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.readers.def;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.xml.namespace.QName;

import org.activebpel.rt.IAeConstants;
import org.activebpel.rt.bpel.AeMessages;
import org.activebpel.rt.bpel.def.AeActivityDef;
import org.activebpel.rt.bpel.def.AeActivityPartnerLinkBaseDef;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.AeCorrelationContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetDef;
import org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeEventHandlersDef;
import org.activebpel.rt.bpel.def.AeFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef;
import org.activebpel.rt.bpel.def.AeImportDef;
import org.activebpel.rt.bpel.def.AeImportsContainerDef;
import org.activebpel.rt.bpel.def.AeMessageExchangesDef;
import org.activebpel.rt.bpel.def.AeNamedDef;
import org.activebpel.rt.bpel.def.AePartnerDef;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.bpel.def.AePartnerLinksContainerDef;
import org.activebpel.rt.bpel.def.AePartnersContainerDef;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef;
import org.activebpel.rt.bpel.def.AeScopeDef;
import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.AeVariablesContainerDef;
import org.activebpel.rt.bpel.def.IAeBPELConstants;
import org.activebpel.rt.bpel.def.IAeMessageExchangesParent;
import org.activebpel.rt.bpel.def.IAeMultipleActivityContainerDef;
import org.activebpel.rt.bpel.def.IAeSingleActivityContainerDef;
import org.activebpel.rt.bpel.def.activity.AeActivityAssignDef;
import org.activebpel.rt.bpel.def.activity.AeActivityBreakDef;
import org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityContinueDef;
import org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityFlowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;
import org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef;
import org.activebpel.rt.bpel.def.activity.AeActivityPickDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReplyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityScopeDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef;
import org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityThrowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWaitDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWhileDef;
import org.activebpel.rt.bpel.def.activity.support.AeAbstractExpressionDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignToDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignVarDef;
import org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;
import org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef;
import org.activebpel.rt.bpel.def.activity.support.AeSourceDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.def.activity.support.AeTargetDef;
import org.activebpel.rt.bpel.def.io.writers.AeCorrelationSetUtil;
import org.activebpel.rt.bpel.def.io.writers.AeImplicitScopeUtil;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;
import org.activebpel.rt.util.AeUtil;
import org.activebpel.rt.util.AeXmlUtil;
import org.activebpel.rt.xml.AeXMLParserBase;
import org.jaxen.JaxenException;
import org.jaxen.XPath;
import org.jaxen.dom.DOMXPath;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

/**
 * Responsible for setting all of the properties on the newly 
 * created AeDef objects and adding them to their parent def.
 */
public class AeReaderVisitor implements IAeDefVisitor, IAeBPELConstants
{
   /** list of errors encountered during parse */
   private List mErrors;
   /** current element being read */
   private Element mCurrentElement;
   /** paren t def object */
   private AeBaseDef mParentDef;
   
   /**
    * Constructor
    * @param aParentDef child will be added to this
    * @param aElement current element to read from
    */
   public AeReaderVisitor( AeBaseDef aParentDef, Element aElement )
   {
      mParentDef = aParentDef;
      mCurrentElement = aElement;
   }
   
   /**
    * Returns true if there are errors encountered during the parse. These errors are
    * significant enough to not add definition object to the process def.
    * 
    * One example of an error like this would be encountering multiple child
    * activities when only one is allowed.
    */
   public boolean hasErrors()
   {
      return mErrors != null;
   }
   
   /**
    * Getter for the errors list.
    */
   public List getErrors()
   {
      if (mErrors == null)
         mErrors = new ArrayList();
      return mErrors;
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityAssignDef)
    */
   public void visit(AeActivityAssignDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef)
    */
   public void visit(AeActivityCompensateDef aDef)
   {
      readAttributes(aDef);
      aDef.setScope(getAttribute(TAG_SCOPE));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef)
    */
   public void visit(AeActivityEmptyDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityContinueDef)
    */
   public void visit(AeActivityContinueDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityBreakDef)
    */
   public void visit(AeActivityBreakDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityFlowDef)
    */
   public void visit(AeActivityFlowDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef)
    */
   public void visit(AeActivityInvokeDef aDef)
   {
      readAttributes(aDef);
      aDef.setInputVariable(getAttribute(TAG_INPUT_VARIABLE));
      aDef.setOutputVariable(getAttribute(TAG_OUTPUT_VARIABLE));
      
      if( AeImplicitScopeUtil.isImplicitScope( getCurrentElement() ) )
      {
         aDef.createImplicitScope();
      }
      
      addActivityToParent(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityPickDef)
    */
   public void visit(AeActivityPickDef aDef)
   {
      readAttributes(aDef);
      aDef.setCreateInstance(getAttributeBoolean(TAG_CREATE_INSTANCE));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef)
    */
   public void visit(AeActivityReceiveDef aDef)
   {
      readAttributes(aDef);
      aDef.setVariable(getAttribute(TAG_VARIABLE));
      aDef.setCreateInstance(getAttributeBoolean(TAG_CREATE_INSTANCE));
      aDef.setMessageExchange(getMessageExchangeValue());
      addActivityToParent(aDef);
   }

   /**
    * Reads the namespace qualified attribute for message exchange.
    */
   protected String getMessageExchangeValue()
   {
      String value = getCurrentElement().getAttributeNS(IAeBPELConstants.ABX_2_0_NAMESPACE_URI, TAG_MESSAGE_EXCHANGE);
      if (value.equals("")) //$NON-NLS-1$
      {
         // sadly, try w/o the namespace to handle legacy case from 2.0 beta where the messageExchange attribute wasn't NS qualified
         value = getCurrentElement().getAttribute(TAG_MESSAGE_EXCHANGE);
      }
      return value;
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReplyDef)
    */
   public void visit(AeActivityReplyDef aDef)
   {
      readAttributes(aDef);
      aDef.setVariable(getAttribute(TAG_VARIABLE));
      aDef.setFaultName(getAttributeQName(TAG_FAULT_NAME));
      aDef.setMessageExchange(getMessageExchangeValue());
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef)
    */
   public void visit(AeActivitySuspendDef aDef)
   {
      readAttributes(aDef);
      aDef.setVariable(getAttribute(TAG_VARIABLE));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityScopeDef)
    */
   public void visit(AeActivityScopeDef aDef)
   {
      readAttributes(aDef);
      aDef.setVariableAccessSerializable(
              getAttributeBoolean(TAG_VARIABLE_ACCESS_SERIALIZABLE));
      addActivityToParent(aDef);
   }

   /**
    * Reads the messageExchanges for the current scope or processDef and returns
    * them as a collection. 
    */
   protected Set readMessageExchanges()
   {
      Set set = readMessageExchanges("./abx:messageExchange"); //$NON-NLS-1$
      if (AeUtil.isNullOrEmpty(set))
      {
         // sadly, check under the legacy namespace if we didn't find anything w/ the 2.0 extension
         set = readMessageExchanges("./abx-legacy:messageExchange"); //$NON-NLS-1$
      }
      return set;
   }

   /**
    * Reads the message exchanges using the xpath provided. This allows us to check 
    * with different paths since the 2.0 beta went out w/o a version number 
    * qualifier for the extension activity namespaces. 
    * @param xpath
    */
   protected Set readMessageExchanges(String xpath)
   {
      Set set = null;

      // read the messageExchange values, if present
      List messageExchangeElements = selectNodes(getCurrentElement(), xpath,
               AeMessages.getString("AeReaderVisitor.ERROR_SELECTING_MESSAGE_EXCHANGES")); //$NON-NLS-1$
      if (!AeUtil.isNullOrEmpty(messageExchangeElements))
      {
         set = new HashSet();
         for (Iterator iter = messageExchangeElements.iterator(); iter.hasNext();)
         {
            Element element = (Element) iter.next();
            set.add(element.getAttribute(TAG_NAME));
         }
      }
      return set;
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef)
    */
   public void visit(AeActivitySequenceDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef)
    */
   public void visit(AeActivitySwitchDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef)
    */
   public void visit(AeActivityTerminateDef aDef)
   {
      readAttributes(aDef);
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityThrowDef)
    */
   public void visit(AeActivityThrowDef aDef)
   {
      readAttributes(aDef);
      aDef.setFaultName(getAttributeQName(TAG_FAULT_NAME));
      aDef.setFaultVariable(getAttribute(TAG_FAULT_VARIABLE));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWaitDef)
    */
   public void visit(AeActivityWaitDef aDef)
   {
      readAttributes(aDef);
      aDef.setFor(getAttribute(TAG_FOR));
      aDef.setUntil(getAttribute(TAG_UNTIL));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWhileDef)
    */
   public void visit(AeActivityWhileDef aDef)
   {
      readAttributes(aDef);
      aDef.setCondition( getAttribute(TAG_CONDITION));
      addActivityToParent(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef)
    */
   public void visit(AeActivityForEachDef aDef)
   {
      readAttributes(aDef);

      aDef.setCounterName(getAttribute(TAG_FOREACH_COUNTERNAME));
      aDef.setParallel(getAttributeBoolean(TAG_FOREACH_PARALLEL));
      
      addActivityToParent(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef)
    */
   public void visit(AeForEachCompletionConditionDef aDef)
   {
      readAttributes(aDef);
      ((AeActivityForEachDef)getParentDef()).setCompletionCondition(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef)
    */
   public void visit(AeForEachFinalDef aDef)
   {
      readAttributes(aDef);

      readExpressionAttributes(aDef);

      ((AeActivityForEachDef)getParentDef()).setFinalDef(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef)
    */
   public void visit(AeForEachStartDef aDef)
   {
      readAttributes(aDef);

      readExpressionAttributes(aDef);

      ((AeActivityForEachDef)getParentDef()).setStartDef(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef)
    */
   public void visit(AeForEachBranchesDef aDef)
   {
      readAttributes(aDef);
      readExpressionAttributes(aDef);
      aDef.setCountCompletedBranchesOnly(getAttributeBoolean(TAG_FOREACH_BRANCH_COUNTCOMPLETED));
      ((AeForEachCompletionConditionDef)getParentDef()).setBranches(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef)
    */
   public void visit(AeAssignCopyDef aDef)
   {
      readAttributes(aDef);
      ((AeActivityAssignDef)getParentDef()).addCopy(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef)
    */
   public void visit(AeAssignFromDef aDef)
   {
      readAttributes(aDef);
      ((AeAssignCopyDef)getParentDef()).setFrom(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignToDef)
    */
   public void visit(AeAssignToDef aDef)
   {
      readAttributes(aDef);
      ((AeAssignCopyDef)getParentDef()).setTo(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationContainerDef)
    */
   public void visit(AeCorrelationContainerDef aDef)
   {
      readAttributes(aDef);
      // don't need to add containers
      // created via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef)
    */
   public void visit(AeCorrelationDef aDef)
   {
      readAttributes(aDef);
      aDef.setCorrelationSetName(getAttribute(TAG_SET));
      aDef.setPattern(getAttribute(TAG_PATTERN));
      aDef.setInitiate(getAttributeBoolean(TAG_INITIATE));
      ((AeCorrelationContainerDef)getParentDef()).add(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef)
    */
   public void visit(AeCorrelationSetContainerDef aDef)
   {
      readAttributes(aDef);
      // don't need to add containers
      // created via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetDef)
    */
   public void visit(AeCorrelationSetDef aDef)
   {
      readAttributes(aDef);
      String rawProperties = getAttribute(TAG_PROPERTIES);
      AeCorrelationSetUtil.addProperties(aDef, rawProperties, getCurrentElement() );
      ((AeCorrelationSetContainerDef)getParentDef()).add(aDef);
   }
   

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef)
    */
   public void visit(AeDefaultFaultHandlerDef aDef)
   {
      readAttributes(aDef);
      // use double dispatch here because default handler def
      // can be added to invoke activity or directly to container
      AeAddDefaultFaultVisitor visitor = new AeAddDefaultFaultVisitor(aDef);
      getParentDef().accept(visitor);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeEventHandlersDef)
    */
   public void visit(AeEventHandlersDef aDef)
   {
      readAttributes(aDef);
      if( getParentDef() instanceof AeActivityScopeDef )
      {
         ((AeActivityScopeDef)getParentDef()).getScope().setEventHandlers(aDef);
         
      }
      else
      {
         ((AeProcessDef)getParentDef()).setEventHandlers(aDef);
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlerDef)
    */
   public void visit(AeFaultHandlerDef aDef)
   {
      readAttributes(aDef);
      aDef.setFaultName(getAttributeQName(TAG_FAULT_NAME));
      aDef.setFaultVariable(getAttribute(TAG_FAULT_VARIABLE));
      
      // could be adding fault handler to an invoke activity or
      // directly to a fault handler container element
      AeAddFaultVisitor visitor = new AeAddFaultVisitor(aDef);
      getParentDef().accept(visitor);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef)
    */
   public void visit(AeFaultHandlersContainerDef aDef)
   {
      readAttributes(aDef);
      // don't have to add container to anything
      // they are created on parent via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef)
    */
   public void visit(AeLinkContainerDef aDef)
   {
      readAttributes(aDef);
      // don't have to add container to anything
      // they are created on parent via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkDef)
    */
   public void visit(AeLinkDef aDef)
   {
      readAttributes( aDef );
      ((AeLinkContainerDef)getParentDef()).add(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeMessageExchangesDef)
    */
   public void visit(AeMessageExchangesDef aDef)
   {
      Set messageExchanges = readMessageExchanges();
      if (!AeUtil.isNullOrEmpty(messageExchanges))
      {
         // using double dispatch here because AeMessageExchangesDef parent
         // could be scope activity or process
         aDef.setMessageExchanges(messageExchanges);
         ((IAeMessageExchangesParent)getParentDef()).setMessageExchangesDef(aDef);
      }
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef)
    */
   public void visit(AeOnAlarmDef aDef)
   {
      readAttributes(aDef);
      aDef.setFor(   getAttribute(TAG_FOR));
      aDef.setUntil( getAttribute(TAG_UNTIL));

      // using double dispatch here because OnAlarmDef parent
      // could be pick activity or event handler
      AeAddOnAlarmVisitor visitor = new AeAddOnAlarmVisitor(aDef);
      getParentDef().accept(visitor);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef)
    */
   public void visit(AeOnMessageDef aDef)
   {
      readAttributes(aDef);
      aDef.setPartnerLink( getAttribute(TAG_PARTNER_LINK));
      aDef.setPortType( getAttributeQName(TAG_PORT_TYPE));
      aDef.setOperation( getAttribute(TAG_OPERATION));
      aDef.setVariable( getAttribute(TAG_VARIABLE));
      aDef.setMessageExchange(getMessageExchangeValue());
      
      
      // using double dispatch here because OnMessageDef parent
      // could be pick activity or event handler
      AeAddOnMessageVisitor visitor = new AeAddOnMessageVisitor(aDef);
      getParentDef().accept( visitor );
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef)
    */
   public void visit(AeOtherwiseDef aDef)
   {
      readAttributes(aDef);
      ((AeActivitySwitchDef)getParentDef()).setOtherwise(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerDef)
    */
   public void visit(AePartnerDef aDef)
   {
      readAttributes(aDef);
      ((AePartnersContainerDef)getParentDef()).add(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinkDef)
    */
   public void visit(AePartnerLinkDef aDef)
   {
      readAttributes(aDef);
      aDef.setPartnerLinkTypeName(getAttributeQName(TAG_PARTNER_LINK_TYPE));
      aDef.setMyRole(getAttribute(TAG_MY_ROLE));
      aDef.setPartnerRole(getAttribute(TAG_PARTNER_ROLE));

      // used to determine if partnerLink def is being added to 
      // partnerLinks container def or if its name is being added
      // to partner def
      AeAddPartnerLinkVisitor visitor = new AeAddPartnerLinkVisitor(aDef);
      getParentDef().accept( visitor );
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinksContainerDef)
    */
   public void visit(AePartnerLinksContainerDef aDef)
   {
      readAttributes(aDef);
      // don't have to add container to anything
      // they are created on parent via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnersContainerDef)
    */
   public void visit(AePartnersContainerDef aDef)
   {
      readAttributes(aDef);
      // don't have to add container to anything
      // they are created on parent via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeProcessDef)
    */
   public void visit(AeProcessDef aDef)
   {
      readAttributes(aDef);
      aDef.setTargetNamespace(getAttribute(TAG_TARGET_NAMESPACE));
      aDef.setQueryLanguage(getAttribute(TAG_QUERY_LANGUAGE));
      aDef.setExpressionLanguage(getAttribute(TAG_EXPRESSION_LANGUAGE));
      aDef.setSuppressJoinFailure(getAttributeBoolean(TAG_SUPPRESS_JOIN_FAILURE));
      aDef.setEnableInstanceCompensation(getAttributeBoolean(TAG_ENABLE_INSTANCE_COMPENSATION));
      aDef.setAbstractProcess(getAttributeBoolean(TAG_ABSTRACT_PROCESS));
      
      // process def doesn't need to be added to anyone
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef)
    */
   public void visit(AeScopeCompensatorContainerDef aDef)
   {
      readAttributes(aDef);
      // don't have to add container to anything
      // they are created on parent via lazy instantiation
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeDef)
    */
   public void visit(AeScopeDef aDef)
   {
      throw new UnsupportedOperationException( 
                                          AeMessages.getString("AeReaderVisitor.ERROR_0") ); //$NON-NLS-1$
   }
   
   

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSourceDef)
    */
   public void visit(AeSourceDef aDef)
   {
      readAttributes(aDef);
      aDef.setLinkName(getAttribute(TAG_LINK_NAME));
      aDef.setTransitionCondition(getAttribute(TAG_TRANSITION_CONDITION));
      ((AeActivityDef)getParentDef()).addSource(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef)
    */
   public void visit(AeSwitchCaseContainerDef aDef)
   {
      throw new UnsupportedOperationException(
                           AeMessages.getString("AeReaderVisitor.ERROR_1")); //$NON-NLS-1$
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef)
    */
   public void visit(AeSwitchCaseDef aDef)
   {
      readAttributes(aDef);
      aDef.setCondition(getAttribute(TAG_CONDITION));
      ((AeActivitySwitchDef)getParentDef()).addCase(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeTargetDef)
    */
   public void visit(AeTargetDef aDef)
   {
      readAttributes(aDef);
      aDef.setLinkName( getAttribute(TAG_LINK_NAME));
      ((AeActivityDef)getParentDef()).addTarget(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariableDef)
    */
   public void visit(AeVariableDef aDef)
   {
      readAttributes(aDef);
      aDef.setMessageType(getAttributeQName(TAG_MESSAGE_TYPE));
      aDef.setType(getAttributeQName(TAG_TYPE));
      aDef.setElement(getAttributeQName(TAG_ELEMENT));
      ((AeVariablesContainerDef)getParentDef()).add(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariablesContainerDef)
    */
   public void visit(AeVariablesContainerDef aDef)
   {
      readAttributes(aDef);
      // containers don't have to be added to
      // their parents - they are accessed through
      // lazy instantiation
   }
   
   /**
    * Set properties on the def object according to its type.
    * @param aCurrentDef
    */
   protected void readAttributes(AeActivityPartnerLinkBaseDef aCurrentDef)
   {
      readStandardAttributes(aCurrentDef);
      readNameAttributes(aCurrentDef);
      readActivityAttributes(aCurrentDef);

      aCurrentDef.setPartnerLink( getCurrentElement().getAttribute(TAG_PARTNER_LINK));
      aCurrentDef.setPortType(    getAttributeQName(getCurrentElement(), TAG_PORT_TYPE));
      aCurrentDef.setOperation(   getCurrentElement().getAttribute(TAG_OPERATION));
   }

   /**
    * Set properties on the def object according to its type.
    * @param aCurrentDef
    */
   protected void readAttributes( AeActivityDef aCurrentDef )
   {
      readStandardAttributes(aCurrentDef);
      readNameAttributes(aCurrentDef);
      readActivityAttributes(aCurrentDef);
   }

   /**
    * Set properties on the def object according to its type.
    * @param aCurrentDef
    */
   protected void readAttributes( AeNamedDef aCurrentDef )
   {
      readStandardAttributes(aCurrentDef );
      readNameAttributes(aCurrentDef);
   }

   /**
    * Sets properties on the assign var def.
    * 
    * @param aVarDef
    */
   protected void readAssignVarDefAttributes( AeAssignVarDef aVarDef)
   {
      readStandardAttributes(aVarDef);
      aVarDef.setVariable(getAttribute(TAG_VARIABLE));
      aVarDef.setProperty(getAttribute(TAG_PROPERTY));
      aVarDef.setPart(getAttribute(TAG_PART));
      aVarDef.setQuery(getAttribute(TAG_QUERY));
      aVarDef.setPartnerLink(getAttribute(TAG_PARTNER_LINK));
   }

   /**
    * Set properties on the def object according to its type.
    * 
    * @param aToDef
    */
   protected void readAttributes( AeAssignToDef aToDef )
   {
      readAssignVarDefAttributes(aToDef);
   }
   
   /**
    * Set properties on the def object according to its type.
    * 
    * @param aFromDef
    */
   protected void readAttributes( AeAssignFromDef aFromDef )
   {
      readAssignVarDefAttributes(aFromDef);
      aFromDef.setEndpointReference(getAttribute(TAG_ENDPOINT_REFERENCE));
      aFromDef.setExpression(getAttribute(TAG_EXPRESSION));
      aFromDef.setOpaque(getAttributeBoolean(TAG_OPAQUE));
      checkForLiteral(aFromDef);
   }
   
   /**
    * Custom readChildren impl to account for literal value.
    * @param aDef the var def impl
    */
   protected void checkForLiteral( AeAssignFromDef aDef )
   {
      if (getCurrentElement().hasChildNodes())
      {
         Element elem = AeXmlUtil.getFirstSubElement(getCurrentElement());
         if(elem != null)
         {
            aDef.setLiteral(elem);
         }
         else
         {
            aDef.setLiteral(getCurrentElement().getFirstChild());
         }
      }
   }


   /**
    * Clones the element passed in. We don't want to use the standard <code>clone()</code>
    * method since the resulting document literal element would have the bpel namespace.
    * As such, this method needs to make an exact copy of the element but using the null
    * namespace.  In order to do this, we'll make a custom "deep" clone of the element by
    * walking all of its children and recreating them in a new Document.
    * 
    * @param aElem
    */
   protected Element cloneElement(Element aElem)
   {
      try
      {
         Document doc = AeXmlUtil.getDocumentBuilder(true, false).newDocument();
         Element rootElem = (Element) doc.importNode(aElem, false);
         String prefix = aElem.getPrefix();
         if (!AeUtil.isNullOrEmpty(prefix))
         {
            String ns = AeXmlUtil.getNamespaceForPrefix(aElem, prefix);
            rootElem.setAttributeNS(IAeConstants.W3C_XMLNS, "xmlns:" + prefix, ns); //$NON-NLS-1$
         }
         AeXmlUtil.copyNodeContents(aElem, rootElem);
         return rootElem;
      }
      catch (Exception e)
      {
         /*
          * There shouldn't be any exception thrown here since the element is obviously
          * already well formed (or it wouldn't be in a DOM) so there shouldn't be any
          * issue reading it back in from a string.
          */
         throw new InternalError(AeMessages.getString("AeReaderVisitor.ERROR_3")); //$NON-NLS-1$
      }
   }

   /**
    * Reads the standard attributes from the current element and sets them on
    * the given def object.
    * 
    * @param aCurrentDefObj
    */
   protected void readAttributes(AeBaseDef aCurrentDefObj)
   {
      readStandardAttributes(aCurrentDefObj);
   }

   /**
    * Reads the attributes common to expression defs
    * @param aDef
    */
   protected void readExpressionAttributes(AeAbstractExpressionDef aDef)
   {
      aDef.setExpression(AeXmlUtil.getText(getCurrentElement()));
      aDef.setExpressionLanguage(getAttribute(TAG_EXPRESSION_LANGUAGE));
   }
   
   /**
    * Read in attributes for activity def.
    * @param aCurrentDef the activity def object
    */
   protected void readActivityAttributes(AeActivityDef aCurrentDef)
   {
      aCurrentDef.setJoinCondition( getCurrentElement().getAttribute(TAG_JOIN_CONDITION));
      aCurrentDef.setSuppressFailure( getAttributeBoolOptional( getCurrentElement(), TAG_SUPPRESS_FAILURE));
   }

   /**
    * Read in attributes for names def.
    * @param aCurrentDef the named def object
    */
   protected void readNameAttributes(AeNamedDef aCurrentDef)
   {
      aCurrentDef.setName( getCurrentElement().getAttribute(TAG_NAME) );
   }

   /**
    * Given the current node element in a DOM tree, this method will read the
    * attributes into memory. This base element is responsible for obtaining
    * a map of all namespaces referenced in the node element.
    * 
    * @param aElement the current node within the DOM tree
    */
   protected void readStandardAttributes(AeBaseDef aCurrentDefObj)
   {
      if (getCurrentElement().hasAttributes())
      {
         // Loop through and add all attributes which are part of the xmlns to the map
         NamedNodeMap attrNodes = getCurrentElement().getAttributes();
         for (int i = 0, length = attrNodes.getLength(); i < length; i++)
         {
            Node attr = attrNodes.item(i);
            if (attr.getNodeName().startsWith("xmlns")) //$NON-NLS-1$
            {
               aCurrentDefObj.addNamespace(attr.getNodeName(), attr.getNodeValue());
            }
         }
      }
   }
   
   /**
    * Convenience method for accessing an attribute from
    * the current context element.
    * @param aAttributeName
    * @return the attribute value
    */
   protected String getAttribute( String aAttributeName )
   {
      return getCurrentElement().getAttribute(aAttributeName);
   }
   
   /**
    * Convenience method for accessing an attribute QName from
    * the current context element.
    * @param aAttributeName
    * @return the QName
    */
   protected QName getAttributeQName( String aAttributeName )
   {
      return getAttributeQName(getCurrentElement(),aAttributeName);
   }
   
   /**
    * Convenience method for accessing an attribute with a
    * boolean value from the current context element.
    * @param aAttributeName
    * @return boolean flag to indicate attribute state 
    */
   protected boolean getAttributeBoolean( String aAttributeName )
   {
      return getAttributeBoolean( getCurrentElement(), aAttributeName );
   }

   /**
    * Facilitates the retrieval of a QName attribute from the element 
    * node which was passed in.
    * 
    * @param aElement
    * @param aAttributeName
    */
   public final static QName getAttributeQName(Element aElement, String aAttributeName)
   {
      String simpleValue = aElement.getAttribute(aAttributeName);
      if (AeUtil.isNullOrEmpty(simpleValue))
      {
         return null;
      }

      if (!AeXmlUtil.hasColon(simpleValue))
      {
         // the attribute value IS NOT a QName. Ergo, we should return the null
         // namespace.
         return new QName(null, simpleValue);
      }
      
      String prefix = AeXmlUtil.extractPrefix(simpleValue);
      String value = AeXmlUtil.extractLocalPart(simpleValue);
      
      String fullNamespace = getNamespaceForPrefix(aElement, prefix);
      return new QName(fullNamespace, value);
   }
   
   /**
    * Walks the element's ancestors looking for the namespace declaration so
    * we can reuse the same prefix when we write it out.
    * @param aElement
    * @param aKey
    */
   public static final String getNamespaceForPrefix(Element aElement, String aKey)
   {
      return AeXmlUtil.getNamespaceForPrefix(aElement, aKey);
   }
   
   /**
    * Facilitates the retrieval of a boolean attribute from the element 
    * node which was passed in. This method makes provisions for attributes 
    * which may be null, in which case a null objects is returned.
    * 
    * @param aElement the element node to be used
    * @param aAttributeName the name of the attribute we are looking for
    * 
    * @return boolean flag to indicate attribute state
    */
   public static final Boolean getAttributeBoolOptional(Element aElement, String aAttributeName)
   {
      Boolean flag = null;
      String attr = aElement.getAttribute(aAttributeName);
      if (attr.length() > 0)
         flag = new Boolean(ATTR_YES.equalsIgnoreCase(attr));
      
      return flag;
   }

   /**
    * Facilitates the retrieval of a boolean attribute from the element 
    * node which was passed in.
    * 
    * @param aElement the element node to be used
    * @param aAttributeName the name of the attribute we are looking for
    * 
    * @return boolean flag to indicate attribute state
    */
   public static final boolean getAttributeBoolean(Element aElement, String aAttributeName)
   {
      return ATTR_YES.equalsIgnoreCase(aElement.getAttribute(aAttributeName));
   }
   
   /**
    * Adds the activity def to the context parent def object.
    * @param aChildDef
    */
   protected void addActivityToParent(AeActivityDef aChildDef)
   {
       // it is necessary to call getScopedAcitivity here because scope could
       // be inlined in AeInvokeActivity
       AeActivityDef activity = aChildDef.getScopedActivity();
   
       if( getParentDef() instanceof IAeMultipleActivityContainerDef )
       {
          ((IAeMultipleActivityContainerDef)getParentDef()).addActivity(activity);   
       }
       else if( getParentDef() instanceof IAeSingleActivityContainerDef )
       {
          IAeSingleActivityContainerDef parent = (IAeSingleActivityContainerDef)getParentDef();
          if (parent.getActivity() == null)
          {
             parent.setActivity(activity);
          }
          else
          {
             getErrors().add(AeMessages.format("AeReaderVisitor.ErrorAddingChild", AeXMLParserBase.documentToString(getCurrentElement()))); //$NON-NLS-1$
          }
       }
       else
       {
          getErrors().add(AeMessages.format("AeReaderVisitor.ErrorInRegistry", AeXMLParserBase.documentToString(getCurrentElement()))); //$NON-NLS-1$
       }
    }

   /**
    * Convenience method for accessing the current element.
    * @return current element being read
    */
   protected Element getCurrentElement()
   {
      return mCurrentElement;
   }
   
   /**
    * Convenience method for accessing the parent def object.
    * @return parent def object
    */
   protected AeBaseDef getParentDef()
   {
      return mParentDef;
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportsContainerDef)
    */
   public void visit(AeImportsContainerDef aDef)
   {
      //no op
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportDef)
    */
   public void visit(AeImportDef aDef)
   {
      //no op
   }

   /**
    * @param aNode
    * @param aPath
    * @param aErrorMessage
    */
   protected static List selectNodes(Node aNode, String aPath, String aErrorMessage)
   {
      try
      {
         XPath xpath = new DOMXPath(aPath);
         xpath.addNamespace("bpws", IAeBPELConstants.BPWS_NAMESPACE_URI); //$NON-NLS-1$
         xpath.addNamespace("abx", IAeBPELConstants.ABX_2_0_NAMESPACE_URI); //$NON-NLS-1$
         xpath.addNamespace("abx-legacy", IAeBPELConstants.ABX_FUNCTIONS_NAMESPACE_URI); //$NON-NLS-1$
         return xpath.selectNodes(aNode);
      }
      catch (JaxenException e)
      {
         throw new RuntimeException(aErrorMessage + " " + e.getLocalizedMessage()); //$NON-NLS-1$
      }
   }
}
