// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/registry/AeDefaultBpelRegistry.java,v 1.2 2004/07/08 13:09:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.registry;

import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.io.readers.def.IAeBpelDefReader;
import org.activebpel.rt.bpel.def.io.writers.def.IAeBpelDefWriter;

import javax.xml.namespace.QName;

/**
 * Default impl of the IAeBpelRegistry.
 * <br />
 * Delegates all of the actual work retrieving readers
 * to the <code>AeDefReaderRegistry</code>.
 * <br />
 * Delegates all of the actual work retrieving writers
 * to the <code>AeDefWriterRegistry</code>.
 */
public class AeDefaultBpelRegistry implements IAeBpelRegistry
{
   
   /** writer registry impl */
   private AeDefWriterRegistry mWriterRegistry = new AeDefWriterRegistry();
   /** reader registry impl */
   private AeDefReaderRegistry mReaderRegistry = new AeDefReaderRegistry();


   /**
    * @see org.activebpel.rt.bpel.def.io.registry.IAeBpelRegistry#getWriter(java.lang.Class, org.activebpel.rt.bpel.def.AeBaseDef)
    */
   public IAeBpelDefWriter getWriter(Class aParentClass, AeBaseDef aDef)
   {
      return mWriterRegistry.getWriter( aParentClass,aDef );
   }

   /**
    * @see org.activebpel.rt.bpel.def.io.registry.IAeBpelRegistry#getReader(org.activebpel.rt.bpel.def.AeBaseDef, javax.xml.namespace.QName)
    */
   public IAeBpelDefReader getReader(AeBaseDef aParentDef, QName aQName)
   {
      return mReaderRegistry.getReader(aParentDef,aQName);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.io.registry.IAeBpelRegistry#getProcessReader()
    */
   public IAeBpelDefReader getProcessReader()
   {
      return mReaderRegistry.getProcessDefReader();
   }
}
