// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/writers/AeBpelDefTraverserVisitor.java,v 1.11 2006/01/11 21:01:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.writers;

import java.util.Iterator;
import java.util.Stack;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.AeMessages;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.AeCorrelationContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetDef;
import org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeEventHandlersDef;
import org.activebpel.rt.bpel.def.AeFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef;
import org.activebpel.rt.bpel.def.AeMessageExchangesDef;
import org.activebpel.rt.bpel.def.AePartnerDef;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.bpel.def.AePartnerLinksContainerDef;
import org.activebpel.rt.bpel.def.AePartnersContainerDef;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef;
import org.activebpel.rt.bpel.def.AeScopeDef;
import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.AeVariablesContainerDef;
import org.activebpel.rt.bpel.def.IAeBPELConstants;
import org.activebpel.rt.bpel.def.activity.AeActivityAssignDef;
import org.activebpel.rt.bpel.def.activity.AeActivityBreakDef;
import org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityContinueDef;
import org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityFlowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;
import org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef;
import org.activebpel.rt.bpel.def.activity.AeActivityPickDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReplyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityScopeDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef;
import org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityThrowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWaitDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWhileDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignToDef;
import org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;
import org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef;
import org.activebpel.rt.bpel.def.activity.support.AeSourceDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.def.activity.support.AeTargetDef;
import org.activebpel.rt.bpel.def.io.ext.IAeExtensionElement;
import org.activebpel.rt.bpel.def.io.ext.IAeExtensionWriter;
import org.activebpel.rt.bpel.def.io.registry.IAeBpelRegistry;
import org.activebpel.rt.bpel.def.io.registry.IAeExtensionRegistry;
import org.activebpel.rt.bpel.def.io.writers.def.IAeBpelDefWriter;
import org.activebpel.rt.bpel.def.visitors.AeAbstractDefVisitor;
import org.activebpel.rt.bpel.def.visitors.AeTraversalVisitor;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Work horse class for traversing and serializing the AeProcessDef
 * object model.
 * <br />
 * The traversal mechanism is driven an AeDefTraverser subclass, the
 * <code>AeInvokeWithScopeTraverser</code>. 
 */
public class AeBpelDefTraverserVisitor extends AeAbstractDefVisitor implements IAeBPELConstants
{
   /** BPEL dom */
   private Document mProcessDoc;
   /** stack for maintaining parent elements */
   private Stack mStack = new Stack();
   /** bpel registry */
   private IAeBpelRegistry mRegistry;
   /** extension registry */ 
   private IAeExtensionRegistry mExtRegistry;
 
   /**
    * Constructor.
    * @param aRegistry to retrieve IAeBpelDefWriter impls
    * @param aExtRegistry to retrieve IAeExtensionWriter impls
    */
   public AeBpelDefTraverserVisitor( IAeBpelRegistry aRegistry, 
                                          IAeExtensionRegistry aExtRegistry )
   {
      init();
      mRegistry = aRegistry;
      mExtRegistry = aExtRegistry;
   }
   
   /**
    * Install the appropriate traversal visitor
    * <br />
    * Override this method to change the traversal behavior.
    */
   protected void init()
   {
      setTraversalVisitor( new AeTraversalVisitor( 
                           new AeInvokeWithScopeTraverser(), this) );
   }
   
   /**
    * Push the current element onto the stack.
    * @param aElement
    */
   private void push(Element aElement)
   {
      mStack.push( aElement );
   }
   
   /**
    * Peek at the top level element.
    * @return the current top level element
    */
   private Element peek()
   {
      return (Element)mStack.peek();
   }
   
   /**
    * Pop the current element off the stack.
    */
   private void pop()
   {
      mStack.pop();
   }
   
   /**
    * Accessor for the serialized process.
    * @return the BPEL xml
    */
   public Document getProcessDoc()
   {
      return mProcessDoc;
   }
   
   /**
    * Serialize any extension elements in the AeDef object.
    * @param aBaseDef
    * @throws AeBpelWriterException
    */
   protected void writeExtensions(AeBaseDef aBaseDef)
   throws AeBpelWriterException
   {
      // no need to go any further if base def was
      // an empty container element 
      if( peek() == null )
      {
         return;
      }
      
      for( Iterator iter = aBaseDef.getExtensions(); iter.hasNext(); )
      {
         IAeExtensionElement extElement = (IAeExtensionElement)iter.next();
         Class parentClass = aBaseDef.getClass();
      
         IAeExtensionWriter writer;
         try
         {
            writer =
               getExtensionRegistry().getExtensionWriter(
                  parentClass,
                  extElement.getElementQName());

            writer.write( peek(), extElement );
         }
         catch (AeBusinessProcessException e)
         {
            throw new AeBpelWriterException(AeMessages.getString("AeBpelDefTraverserVisitor.ERROR_0"),e); //$NON-NLS-1$
         }
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityAssignDef)
    */
   public void visit(AeActivityAssignDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef)
    */
   public void visit(AeActivityCompensateDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef)
    */
   public void visit(AeActivityEmptyDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityFlowDef)
    */
   public void visit(AeActivityFlowDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef)
    */
   public void visit(AeActivityInvokeDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityPickDef)
    */
   public void visit(AeActivityPickDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef)
    */
   public void visit(AeActivityReceiveDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReplyDef)
    */
   public void visit(AeActivityReplyDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef)
    */
   public void visit(AeActivitySuspendDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityScopeDef)
    */
   public void visit(AeActivityScopeDef aDef)
   {
      Element element = null;

      if( AeImplicitScopeUtil.isInlinedInvokeScope(aDef) )
      {
         AeImplicitScopeUtil.syncObjectStates(aDef);
         AeActivityInvokeDef invoke = AeImplicitScopeUtil.getActivityInvoke(aDef);
         element = createElement(invoke);
         push(element);
         super.visit(invoke);
         AeImplicitScopeUtil.restoreObjectStates(aDef);
      }
      else
      {
         element = createElement(aDef);
         push(element);
         super.visit(aDef);
      }

      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef)
    */
   public void visit(AeActivitySequenceDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef)
    */
   public void visit(AeActivitySwitchDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef)
    */
   public void visit(AeActivityTerminateDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityThrowDef)
    */
   public void visit(AeActivityThrowDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWaitDef)
    */
   public void visit(AeActivityWaitDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef)
    */
   public void visit(AeActivityForEachDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWhileDef)
    */
   public void visit(AeActivityWhileDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityContinueDef)
    */
   public void visit(AeActivityContinueDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityContinueDef)
    */
   public void visit(AeActivityBreakDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef)
    */
   public void visit(AeAssignCopyDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef)
    */
   public void visit(AeAssignFromDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignToDef)
    */
   public void visit(AeAssignToDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationContainerDef)
    */
   public void visit(AeCorrelationContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef)
    */
   public void visit(AeCorrelationDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef)
    */
   public void visit(AeCorrelationSetContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetDef)
    */
   public void visit(AeCorrelationSetDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef)
    */
   public void visit(AeDefaultFaultHandlerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeEventHandlersDef)
    */
   public void visit(AeEventHandlersDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlerDef)
    */
   public void visit(AeFaultHandlerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef)
    */
   public void visit(AeFaultHandlersContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef)
    */
   public void visit(AeLinkContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkDef)
    */
   public void visit(AeLinkDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef)
    */
   public void visit(AeForEachFinalDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef)
    */
   public void visit(AeForEachStartDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef)
    */
   public void visit(AeForEachBranchesDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef)
    */
   public void visit(AeForEachCompletionConditionDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeMessageExchangesDef)
    */
   public void visit(AeMessageExchangesDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef)
    */
   public void visit(AeOnAlarmDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef)
    */
   public void visit(AeOnMessageDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef)
    */
   public void visit(AeOtherwiseDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerDef)
    */
   public void visit(AePartnerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinkDef)
    */
   public void visit(AePartnerLinkDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinksContainerDef)
    */
   public void visit(AePartnerLinksContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnersContainerDef)
    */
   public void visit(AePartnersContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeProcessDef)
    */
   public void visit(AeProcessDef aDef)
   {
      Element processElement = getWriter(aDef).createElement(aDef,null);
      mProcessDoc = processElement.getOwnerDocument();
      push(processElement);
      super.visit(aDef);
      writeExtensions(aDef);
   }
   

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef)
    */
   public void visit(AeScopeCompensatorContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeDef)
    */
   public void visit(AeScopeDef aDef)
   {
      super.visit(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSourceDef)
    */
   public void visit(AeSourceDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef)
    */
   public void visit(AeSwitchCaseContainerDef aDef)
   {
      // the issue here is that the switch case container isn't
      // represented in the xml - all children should be added
      // directly to the swtich element
      super.visit(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef)
    */
   public void visit(AeSwitchCaseDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeTargetDef)
    */
   public void visit(AeTargetDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariableDef)
    */
   public void visit(AeVariableDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariablesContainerDef)
    */
   public void visit(AeVariablesContainerDef aDef)
   {
      Element element = createElement(aDef);
      push(element);
      super.visit(aDef);
      writeExtensions(aDef);
      pop();
   }
      
   /**
    * Serialize the AeDef object
    * @param aBaseDef
    * @return BPEL element
    */
   protected Element createElement( AeBaseDef aBaseDef )
   {
      return getWriter(aBaseDef).createElement(aBaseDef,peek());
   }

   /**
    * Accessor for the IAeBpelDefWriter.
    * @param aBaseDef
    * @return IAeBpelDefWriter impl
    */
   protected IAeBpelDefWriter getWriter(AeBaseDef aBaseDef)
   {
     
     // TODO Z! - noticed that when BPEP firsts starts up
     // it does a serialization call and it looked like all
     // of the def objs had null parents - not really an
     // issue for this impl of serialization, where the 
     // AeDef traverser drives the parent child relationship
     // but it would be an issue if another writer impl
     // required the parent class to look up potential child
     // writers for its children  
      Class parentClass = null;
      
      if( aBaseDef.getParent() != null )
      {
         parentClass = aBaseDef.getClass();
      }
      
      return getBpelRegistry().getWriter( parentClass, aBaseDef );
   }

   /**
    * @return registry member
    */
   private IAeBpelRegistry getBpelRegistry()
   {
      return mRegistry;
   }
   
   /**
    * @return extension registry member
    */
   private IAeExtensionRegistry getExtensionRegistry()
   {
      return mExtRegistry;
   }
}


