// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/io/writers/def/AeWriterVisitor.java,v 1.19 2006/01/26 18:11:0
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.io.writers.def;

import java.util.Iterator;
import java.util.Set;

import javax.xml.namespace.QName;

import org.activebpel.rt.IAeConstants;
import org.activebpel.rt.bpel.def.AeActivityDef;
import org.activebpel.rt.bpel.def.AeActivityPartnerLinkBaseDef;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.AeCorrelationContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetDef;
import org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeEventHandlersDef;
import org.activebpel.rt.bpel.def.AeFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef;
import org.activebpel.rt.bpel.def.AeImportDef;
import org.activebpel.rt.bpel.def.AeImportsContainerDef;
import org.activebpel.rt.bpel.def.AeMessageExchangesDef;
import org.activebpel.rt.bpel.def.AeNamedDef;
import org.activebpel.rt.bpel.def.AePartnerDef;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.bpel.def.AePartnerLinksContainerDef;
import org.activebpel.rt.bpel.def.AePartnersContainerDef;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef;
import org.activebpel.rt.bpel.def.AeScopeDef;
import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.AeVariablesContainerDef;
import org.activebpel.rt.bpel.def.IAeBPELConstants;
import org.activebpel.rt.bpel.def.activity.AeActivityAssignDef;
import org.activebpel.rt.bpel.def.activity.AeActivityBreakDef;
import org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityContinueDef;
import org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityFlowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;
import org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef;
import org.activebpel.rt.bpel.def.activity.AeActivityPickDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReplyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityScopeDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef;
import org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityThrowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWaitDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWhileDef;
import org.activebpel.rt.bpel.def.activity.support.AeAbstractExpressionDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignToDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignVarDef;
import org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;
import org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef;
import org.activebpel.rt.bpel.def.activity.support.AeSourceDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.def.activity.support.AeTargetDef;
import org.activebpel.rt.bpel.def.io.AeCommentIO;
import org.activebpel.rt.bpel.def.io.writers.AeCorrelationSetUtil;
import org.activebpel.rt.bpel.def.visitors.IAeDefVisitor;
import org.activebpel.rt.util.AeUtil;
import org.activebpel.rt.util.AeXmlUtil;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 * 
 */
public class AeWriterVisitor implements IAeDefVisitor, IAeBPELConstants
{
   /** The current element. */
   private Element mElement;
   
   /**
    * Creates a new element under the passed parent and starts visitng for it.
    * @param aParentElement The parent element of the objects created.
    * @param aNamespace The namespace of the element we're creating
    * @param aTagName The tag of the new element to create.
    */
   public AeWriterVisitor( Element aParentElement, String aNamespace, String aTagName )
   {
      mElement = createElement(aParentElement, aNamespace, aTagName);
      addChildToParent( aParentElement );
   }
   
   /**
    * Adds the current element to the passed parent.
    */
   protected void addChildToParent( Element aParentElement )
   {
      aParentElement.appendChild( getElement() );
   }
   
   /**
    * @return Element the current element being written to.
    */
   public Element getElement()
   {
      return mElement;
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityAssignDef)
    */
   public void visit(AeActivityAssignDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef)
    */
   public void visit(AeActivityCompensateDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(getElement(), TAG_SCOPE, aDef.getScope());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef)
    */
   public void visit(AeActivityEmptyDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityContinueDef)
    */
   public void visit(AeActivityContinueDef aDef)
   {
      writeAttributes(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityBreakDef)
    */
   public void visit(AeActivityBreakDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityFlowDef)
    */
   public void visit(AeActivityFlowDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef)
    */
   public void visit(AeActivityInvokeDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_INPUT_VARIABLE, aDef.getInputVariable());
      setAttribute(TAG_OUTPUT_VARIABLE, aDef.getOutputVariable());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityPickDef)
    */
   public void visit(AeActivityPickDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_CREATE_INSTANCE,aDef.isCreateInstance(), false);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef)
    */
   public void visit(AeActivityReceiveDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_VARIABLE, aDef.getVariable());
      setAttribute(TAG_CREATE_INSTANCE, aDef.isCreateInstance(), false);
      writeMessageExchange(aDef.getMessageExchange());
   }
   
   /**
    * Writes the message exchange value if not empty or null.
    * @param aMessageExchangeValue
    */
   protected void writeMessageExchange(String aMessageExchangeValue)
   {
      if (AeUtil.notNullOrEmpty(aMessageExchangeValue))
      {
         String prefix = AeXmlUtil.getOrCreatePrefix(getElement(), IAeBPELConstants.ABX_2_0_NAMESPACE_URI);
         getElement().setAttributeNS(IAeBPELConstants.ABX_2_0_NAMESPACE_URI, 
                                     prefix + ":" + TAG_MESSAGE_EXCHANGE,  //$NON-NLS-1$
                                     aMessageExchangeValue);
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReplyDef)
    */
   public void visit(AeActivityReplyDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_VARIABLE, aDef.getVariable());
      setAttribute(TAG_FAULT_NAME, aDef.getFaultName());
      writeMessageExchange(aDef.getMessageExchange());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef)
    */
   public void visit(AeActivitySuspendDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_VARIABLE, aDef.getVariable());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityScopeDef)
    */
   public void visit(AeActivityScopeDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_VARIABLE_ACCESS_SERIALIZABLE, aDef.getVariableAccessSerializable(), true);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef)
    */
   public void visit(AeActivitySequenceDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef)
    */
   public void visit(AeActivitySwitchDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef)
    */
   public void visit(AeActivityTerminateDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityThrowDef)
    */
   public void visit(AeActivityThrowDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_FAULT_NAME, aDef.getFaultName());
      setAttribute(TAG_FAULT_VARIABLE, aDef.getFaultVariable());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWaitDef)
    */
   public void visit(AeActivityWaitDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_FOR,   aDef.getFor());
      setAttribute(TAG_UNTIL, aDef. getUntil());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWhileDef)
    */
   public void visit(AeActivityWhileDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_CONDITION, aDef.getCondition());
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef)
    */
   public void visit(AeActivityForEachDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_FOREACH_COUNTERNAME, aDef.getCounterName());
      setAttribute(TAG_FOREACH_PARALLEL, aDef.isParallel(), true);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef)
    */
   public void visit(AeForEachCompletionConditionDef aDef)
   {
      writeStandardAttributes(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef)
    */
   public void visit(AeForEachFinalDef aDef)
   {
      writeExpressionDef(aDef);
   }
   
   /**
    * Writes the expression and expression language for the def
    * @param aDef
    */
   protected void writeExpressionDef(AeAbstractExpressionDef aDef)
   {
      getElement().appendChild(getElement().getOwnerDocument().createTextNode(aDef.getExpression()));
      if (AeUtil.notNullOrEmpty(aDef.getExpressionLanguage()))
      {
         setAttribute(TAG_EXPRESSION_LANGUAGE, aDef.getExpressionLanguage());
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef)
    */
   public void visit(AeForEachStartDef aDef)
   {
      writeExpressionDef(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef)
    */
   public void visit(AeForEachBranchesDef aDef)
   {
      writeExpressionDef(aDef);
      setAttribute(TAG_FOREACH_BRANCH_COUNTCOMPLETED, aDef.isCountCompletedBranchesOnly(), false);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef)
    */
   public void visit(AeAssignCopyDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef)
    */
   public void visit(AeAssignFromDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignToDef)
    */
   public void visit(AeAssignToDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationContainerDef)
    */
   public void visit(AeCorrelationContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef)
    */
   public void visit(AeCorrelationDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_SET, aDef.getCorrelationSetName());
      setAttribute(TAG_PATTERN, aDef.getPattern());
      setAttribute(TAG_INITIATE, aDef.isInitiate(), false);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef)
    */
   public void visit(AeCorrelationSetContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetDef)
    */
   public void visit(AeCorrelationSetDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_PROPERTIES, 
               AeCorrelationSetUtil.formatProperties(aDef,getElement()));
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef)
    */
   public void visit(AeDefaultFaultHandlerDef aDef)
   {
      // no attributes to write
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeEventHandlersDef)
    */
   public void visit(AeEventHandlersDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlerDef)
    */
   public void visit(AeFaultHandlerDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_FAULT_NAME, aDef.getFaultName());
      setAttribute(TAG_FAULT_VARIABLE, aDef.getFaultVariable());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef)
    */
   public void visit(AeFaultHandlersContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef)
    */
   public void visit(AeLinkContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkDef)
    */
   public void visit(AeLinkDef aDef)
   {
      writeAttributes(aDef);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeMessageExchangesDef)
    */
   public void visit(AeMessageExchangesDef aDef)
   {
      if (!AeUtil.isNullOrEmpty(aDef.getMessageExchanges()))
      {
         Set messageExchanges = aDef.getMessageExchanges();
         for (Iterator iter = messageExchanges.iterator(); iter.hasNext();)
         {
            String messageExchangeValue = (String) iter.next();
            Element childMessageExchangeElement = createElement(getElement(),
                  IAeBPELConstants.ABX_2_0_NAMESPACE_URI, TAG_SCOPE_MESSAGEEXCHANGE);
            childMessageExchangeElement.setAttribute(TAG_NAME, messageExchangeValue);
            getElement().appendChild(childMessageExchangeElement);
         }
      }
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef)
    */
   public void visit(AeOnAlarmDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_FOR,   aDef.getFor());
      setAttribute(TAG_UNTIL, aDef.getUntil());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef)
    */
   public void visit(AeOnMessageDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_PARTNER_LINK,   aDef.getPartnerLink());
      setAttribute(TAG_PORT_TYPE, aDef.getPortType());
      setAttribute(TAG_OPERATION, aDef.getOperation());
      setAttribute(TAG_VARIABLE, aDef.getVariable());
      writeMessageExchange(aDef.getMessageExchange());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef)
    */
   public void visit(AeOtherwiseDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerDef)
    */
   public void visit(AePartnerDef aDef)
   {
      writeAttributes(aDef);

      for(Iterator iter=aDef.getPartnerLinks(); iter.hasNext();)
      {
         Element element = getElement().getOwnerDocument().createElementNS(BPWS_NAMESPACE_URI, TAG_PARTNER_LINK);
         // use setAttribute to ensure Attr impl is NS aware
         setAttribute(element,TAG_NAME,(String)iter.next());
         getElement().appendChild(element);
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinkDef)
    */
   public void visit(AePartnerLinkDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_PARTNER_LINK_TYPE, aDef.getPartnerLinkTypeName());
      setAttribute(TAG_MY_ROLE, aDef.getMyRole());
      setAttribute(TAG_PARTNER_ROLE, aDef.getPartnerRole());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinksContainerDef)
    */
   public void visit(AePartnerLinksContainerDef aDef)
   {
      writeAttributes(aDef);
   }
   

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnersContainerDef)
    */
   public void visit(AePartnersContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeProcessDef)
    */
   public void visit(AeProcessDef aDef)
   {
      // Add preamble comment if available (user comments written with attributes method)
      if(! AeUtil.isNullOrEmpty(aDef.getProcessPreambleComment()))
      {
         Document doc = getElement().getOwnerDocument();
         Node commentNode = doc.createComment(aDef.getProcessPreambleComment());
         getElement().getParentNode().insertBefore( commentNode, getElement() );
      }

      writeAttributes(aDef);

      setAttribute(TAG_TARGET_NAMESPACE, aDef.getTargetNamespace());
      setAttribute(TAG_QUERY_LANGUAGE, aDef.getQueryLanguage());
      setAttribute(TAG_EXPRESSION_LANGUAGE, aDef.getExpressionLanguage());

      setAttribute(TAG_SUPPRESS_JOIN_FAILURE, aDef.getSuppressJoinFailure(), false);
      setAttribute(TAG_ENABLE_INSTANCE_COMPENSATION, aDef.getEnableInstanceCompensation(), false);
      setAttribute(TAG_ABSTRACT_PROCESS, aDef.isAbstractProcess(), false);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef)
    */
   public void visit(AeScopeCompensatorContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeDef)
    */
   public void visit(AeScopeDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSourceDef)
    */
   public void visit(AeSourceDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_LINK_NAME, aDef.getLinkName());
      setAttribute(TAG_TRANSITION_CONDITION, aDef.getTransitionCondition());

   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef)
    */
   public void visit(AeSwitchCaseContainerDef aDef)
   {
      writeAttributes(aDef);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef)
    */
   public void visit(AeSwitchCaseDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_CONDITION, aDef.getCondition());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeTargetDef)
    */
   public void visit(AeTargetDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_LINK_NAME,aDef.getLinkName());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariableDef)
    */
   public void visit(AeVariableDef aDef)
   {
      writeAttributes(aDef);
      setAttribute(TAG_MESSAGE_TYPE, aDef.getMessageType());
      setAttribute(TAG_TYPE, aDef.getType());
      setAttribute(TAG_ELEMENT, aDef.getElement());
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariablesContainerDef)
    */
   public void visit(AeVariablesContainerDef aDef)
   {
      writeAttributes(aDef);
   }
   
   protected void writeAttributes( AeActivityPartnerLinkBaseDef aDef )
   {
      writeStandardAttributes(aDef);
      writeNamedAttributes(aDef);
      writeActivityAttributes(aDef);   
      writeActivityPartnerLinkBasedAttributes(aDef);      
   }
   
   protected void writeAttributes( AeActivityDef aDef )
   {
      writeStandardAttributes(aDef);
      writeNamedAttributes(aDef);
      writeActivityAttributes(aDef);   
   }
   
   protected void writeAttributes( AeNamedDef aDef )
   {
      writeStandardAttributes(aDef);
      writeNamedAttributes(aDef);
   }
   
   protected void writeAttributes( AeAssignToDef aDef )
   {
      writeStandardAttributes(aDef);
      writeAssignToAttributes(aDef);
   }

   protected void writeAttributes( AeAssignFromDef aDef )
   {
      writeStandardAttributes(aDef);
      writeAssignFromAttributes(aDef);
   }

   protected void writeAttributes(AeBaseDef aDef)
   {
      writeStandardAttributes(aDef);
   }
   
   protected void writeActivityPartnerLinkBasedAttributes(AeActivityPartnerLinkBaseDef aDef )
   {
      setAttribute(TAG_PARTNER_LINK, aDef.getPartnerLink());
      setAttribute(TAG_PORT_TYPE, aDef.getPortType());
      setAttribute(TAG_OPERATION, aDef.getOperation());
   }
   
   protected void writeActivityAttributes( AeActivityDef aDef )
   {
      setAttribute(TAG_JOIN_CONDITION, aDef.getJoinCondition());
      
      // Suppress join failure is an optional flag, do not set if null
      if (aDef.getSuppressFailure() != null)
      {
         setAttribute(TAG_SUPPRESS_FAILURE,  
                     aDef.getSuppressFailure().booleanValue(), true);
      }
   }
   
   protected void writeNamedAttributes(AeNamedDef aDef)
   {
      setAttribute(TAG_NAME, aDef.getName());
   }
   
   protected void writeAssignVarAttributes(AeAssignVarDef aDef)
   {
      setAttribute(TAG_VARIABLE, aDef.getVariable());
      setAttribute(TAG_PROPERTY, aDef.getProperty());
      setAttribute(TAG_PART, aDef.getPart());
      setAttribute(TAG_QUERY, aDef.getQuery());
      setAttribute(TAG_PARTNER_LINK, aDef.getPartnerLink());
   }
   
   protected void writeAssignToAttributes(AeAssignToDef aDef)
   {
      writeAssignVarAttributes(aDef);
   }

   protected void writeAssignFromAttributes(AeAssignFromDef aDef)
   {
      writeAssignVarAttributes(aDef);
      setAttribute(TAG_ENDPOINT_REFERENCE, aDef.getEndpointReference());
      setAttribute(TAG_EXPRESSION, aDef.getExpression());
      setAttribute(TAG_OPAQUE, aDef.getOpaque(), false);

      if (aDef.getLiteral() != null)
      {
         getElement().appendChild(getElement().getOwnerDocument().importNode(
            aDef.getLiteral(), true));
      }
   }

   protected void writeStandardAttributes(AeBaseDef aBaseDef)
   {
      AeCommentIO.writeFormattedComments( getElement(), aBaseDef.getComment() );
      writeNamespaceAttributes( aBaseDef, getElement() );      
   }


   /**
    * Responsible for writing out namespace attributes for the created element.
    * @param aElement current element node in the tree.
    */
   protected void writeNamespaceAttributes(AeBaseDef aBaseDef, Element aElement)
   {
      for (Iterator iter = aBaseDef.getNamespaceList(); iter.hasNext();)
      {
         String key   = (String)iter.next();
         aElement.setAttributeNS(IAeConstants.W3C_XMLNS, key, aBaseDef.findNamespace(key));
      }
   }
   
   protected void setAttribute( String aAttrName, String aAttrValue )
   {
      setAttribute( getElement(), aAttrName, aAttrValue );
   }

   /**
    * Facilitates setting an attribute within the element node which was passed in.
    * 
    * @param aElement the element node which will be used to set the attribute.
    * @param aAttrName the name of the attribute we are setting
    * @param aAttrValue the value of the attribute we are setting
    */
   public final static void setAttribute(Element aElement, String aAttrName, String aAttrValue)
   {
      if (aAttrValue != null && aAttrValue.length() > 0)
      {
         aElement.setAttributeNS(null, aAttrName, aAttrValue);
      }
   }
   
   protected void setAttribute(String aAttrName, boolean aValue, boolean aRequired)
   {
      setAttribute( getElement(), aAttrName, aValue, aRequired );      
   }
   
   /**
    * Facilitates setting a boolean attribute within the element node which was passed in.
    * The aRequired flag will suppress the attribute generation if set to FALSE and if
    * the aAttrValue is false as well.
    * 
    * @param aElement the element node which will be used to set the attribute
    * @param aAttrName the name of the attribute we are setting
    * @param aAttrValue the value of the attribute we are setting
    * @param aRequired flag indicating if the attribute is required in the document
    */
   public static void setAttribute(Element aElement, String aAttrName, boolean aValue, boolean aRequired)
   {
      // Set the attribute if it is required OR if it is optional and 
      // value is FALSE.  Otherwise no need to set it.
      if (aRequired || (!aRequired && aValue))
      {
         aElement.setAttributeNS(null, aAttrName, (aValue ? ATTR_YES : ATTR_NO));
      }
   }
   
   public void setAttribute(String aAttributeName, QName aQName)
   {
      setAttribute(getElement(),aAttributeName,aQName);
   }

   /**
    * Facilitates setting a QName attribute within the element node which was passed in.
    * @param aElement The element to create the attribute within
    * @param aAttributeName the attribute name to be created
    * @param aQName The qualified name to be written if null, then no attribute is created.
    */
   public static void setAttribute(Element aElement, String aAttributeName, QName aQName)
   {
      if(aQName != null)
      {
         if (AeUtil.isNullOrEmpty(aQName.getNamespaceURI()))
         {
            setAttribute(aElement, aAttributeName, aQName.getLocalPart());
         }
         else
         {
            String prefix = AeXmlUtil.getPrefixForNamespace(aElement, aQName.getNamespaceURI(), false);
            if (AeUtil.isNullOrEmpty(prefix))
            {
               setAttribute(aElement, aAttributeName, aQName.getLocalPart());
            }
            else
            {
               StringBuffer bugger = new StringBuffer();
               bugger.append(prefix).append(':').append(aQName.getLocalPart());
               aElement.setAttributeNS(null, aAttributeName, bugger.toString());
            }
         }
      }
   }
   
   /**
    * Utility method for creating a NS aware DOM element.
    * The element will be created with the default BPEL namespace.
    * @param aParentElement used to get a reference to the owner doc
    * @param aNamespace the namespace of the element we're creating
    * @param aName the element tag name
    * @return the newly created element
    */
   protected Element createElement(Element aParentElement, String aNamespace, String aName)
   {
      if (!IAeBPELConstants.BPWS_NAMESPACE_URI.equals(aNamespace))
      {
         // if the element we're writing is in a namespace other than the bpel
         // namespace then we want to write the element with a prefix
         
         // check to see if there is a prefix already available for this namespace 
         String prefix = AeXmlUtil.getOrCreatePrefix(aParentElement, aNamespace);
         
         // if we have a non-null prefix then create the element with that prefix
         String elementName = AeUtil.notNullOrEmpty(prefix) ? prefix + ":" + aName : aName; //$NON-NLS-1$
         return aParentElement.getOwnerDocument().createElementNS(
               aNamespace, elementName);
      }
      else
      {
         return aParentElement.getOwnerDocument().createElementNS(
                                                      aNamespace, aName);
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportsContainerDef)
    */
   public void visit(AeImportsContainerDef aDef)
   {
      // Do not visit. BPEL v1.1 does not support imports
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportDef)
    */
   public void visit(AeImportDef aDef)
   {
      // Do not visit. BPEL v1.1 does not support imports
   }
}
