//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/visitors/AeCreateInstanceVisitor.java,v 1.1 2006/02/10 17:02:2
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.visitors; 

import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;

public class AeCreateInstanceVisitor extends AeAbstractEntryPointVisitor
{
   /** tracks if we've seen a create instance visitor */
   private boolean mCreateInstanceFound = false;
   
   /**
    * Keep traversing until we find a create instance 
    * @see org.activebpel.rt.bpel.def.visitors.AeAbstractDefVisitor#traverse(org.activebpel.rt.bpel.def.AeBaseDef)
    */
   protected void traverse(AeBaseDef aDef)
   {
      if (!isCreateInstanceFound())
      {
         super.traverse(aDef);
      }
   }

   /**
    * Sets a flag that we've found a create instance
    * @see org.activebpel.rt.bpel.def.visitors.AeAbstractEntryPointVisitor#processEntryPoint(org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef)
    */
   protected void processEntryPoint(AeActivityReceiveDef aDef)
   {
      mCreateInstanceFound = true;
   }

   /**
    * Sets a flag that we've found a create instance
    * @see org.activebpel.rt.bpel.def.visitors.AeAbstractEntryPointVisitor#processEntryPoint(org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef)
    */
   protected void processEntryPoint(AeOnMessageDef aDef)
   {
      mCreateInstanceFound = true;
   }
   
   /**
    * Getter for the create instance found field
    */
   public boolean isCreateInstanceFound()
   {
      return mCreateInstanceFound;
   }
}
 
