//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/visitors/AeDefPartnerLinkTypeVisitor.java,v 1.2 2006/01/25 22:11:5
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.visitors; 

import org.activebpel.rt.bpel.AeMessages;
import org.activebpel.rt.bpel.AeWSDLDefHelper;
import org.activebpel.rt.bpel.IAeWSDLProvider;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.wsdl.def.AeBPELExtendedWSDLDef;
import org.activebpel.rt.wsdl.def.IAePartnerLinkType;

/**
 * Sets the IAePartnerLinkType reference on each of the partner link def objects. 
 */
public class AeDefPartnerLinkTypeVisitor extends AeAbstractDefVisitor
{
   /** wsdl provider used to find partner link type definition elements */
   private IAeWSDLProvider mProvider;
   
   /**
    * Creates the visitor with the default traverser 
    */
   public AeDefPartnerLinkTypeVisitor(IAeWSDLProvider aProvider)
   {
      setTraversalVisitor( new AeTraversalVisitor(new AeDefTraverser(), this));
      mProvider = aProvider;
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinkDef)
    */
   public void visit(AePartnerLinkDef aDef)
   {
      AeBPELExtendedWSDLDef wsdlDef = AeWSDLDefHelper.getWSDLDefinitionForPLT(mProvider, aDef.getPartnerLinkTypeName());
      if (wsdlDef == null)
         throw new RuntimeException(AeMessages.getString("AeDefPartnerLinkTypeVisitor.0")); //$NON-NLS-1$
      
      IAePartnerLinkType plType = wsdlDef.getPartnerLinkType(aDef.getPartnerLinkTypeName().getLocalPart());
      if (plType == null)
         throw new RuntimeException(AeMessages.getString("AeDefPartnerLinkTypeVisitor.0")); //$NON-NLS-1$
      
      aDef.setPartnerLinkType(plType);
      super.visit(aDef);
   }
}
 
