// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/visitors/AeDefToImplVisitor.java,v 1.23 2006/01/11 21:01:0
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.visitors;

import java.util.Stack;

import org.activebpel.rt.bpel.AeMessages;
import org.activebpel.rt.bpel.IAeActivity;
import org.activebpel.rt.bpel.IAeBusinessProcess;
import org.activebpel.rt.bpel.def.AeBaseDef;
import org.activebpel.rt.bpel.def.AeCorrelationContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef;
import org.activebpel.rt.bpel.def.AeCorrelationSetDef;
import org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeEventHandlersDef;
import org.activebpel.rt.bpel.def.AeFaultHandlerDef;
import org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef;
import org.activebpel.rt.bpel.def.AeImportDef;
import org.activebpel.rt.bpel.def.AeImportsContainerDef;
import org.activebpel.rt.bpel.def.AeMessageExchangesDef;
import org.activebpel.rt.bpel.def.AePartnerDef;
import org.activebpel.rt.bpel.def.AePartnerLinkDef;
import org.activebpel.rt.bpel.def.AePartnerLinksContainerDef;
import org.activebpel.rt.bpel.def.AePartnersContainerDef;
import org.activebpel.rt.bpel.def.AeProcessDef;
import org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef;
import org.activebpel.rt.bpel.def.AeScopeDef;
import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.AeVariablesContainerDef;
import org.activebpel.rt.bpel.def.activity.AeActivityAssignDef;
import org.activebpel.rt.bpel.def.activity.AeActivityBreakDef;
import org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityContinueDef;
import org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityFlowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;
import org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef;
import org.activebpel.rt.bpel.def.activity.AeActivityPickDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef;
import org.activebpel.rt.bpel.def.activity.AeActivityReplyDef;
import org.activebpel.rt.bpel.def.activity.AeActivityScopeDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef;
import org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef;
import org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef;
import org.activebpel.rt.bpel.def.activity.AeActivityThrowDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWaitDef;
import org.activebpel.rt.bpel.def.activity.AeActivityWhileDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef;
import org.activebpel.rt.bpel.def.activity.support.AeAssignToDef;
import org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef;
import org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeLinkDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef;
import org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef;
import org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef;
import org.activebpel.rt.bpel.def.activity.support.AeSourceDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.def.activity.support.AeTargetDef;
import org.activebpel.rt.bpel.impl.AeBusinessProcess;
import org.activebpel.rt.bpel.impl.AePartnerLink;
import org.activebpel.rt.bpel.impl.AeVariable;
import org.activebpel.rt.bpel.impl.IAeActivityParent;
import org.activebpel.rt.bpel.impl.IAeBpelObject;
import org.activebpel.rt.bpel.impl.IAeBusinessProcessEngineInternal;
import org.activebpel.rt.bpel.impl.IAeProcessPlan;
import org.activebpel.rt.bpel.impl.activity.AeActivityAssignImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityBreakImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityCompensateImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityContinueImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityEmptyImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityFlowImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityForEachImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityForEachParallelImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityInvokeImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityPickImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityReceiveImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityReplyImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityScopeImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivitySequenceImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivitySuspendImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivitySwitchImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityTerminateImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityThrowImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityWaitImpl;
import org.activebpel.rt.bpel.impl.activity.AeActivityWhileImpl;
import org.activebpel.rt.bpel.impl.activity.IAeEventParent;
import org.activebpel.rt.bpel.impl.activity.support.AeCompensationHandler;
import org.activebpel.rt.bpel.impl.activity.support.AeCorrelationSet;
import org.activebpel.rt.bpel.impl.activity.support.AeDefaultFaultHandler;
import org.activebpel.rt.bpel.impl.activity.support.AeEventHandlersContainer;
import org.activebpel.rt.bpel.impl.activity.support.AeFaultHandler;
import org.activebpel.rt.bpel.impl.activity.support.AeLink;
import org.activebpel.rt.bpel.impl.activity.support.AeOnAlarm;
import org.activebpel.rt.bpel.impl.activity.support.AeOnMessage;
import org.activebpel.rt.bpel.impl.activity.support.AeSwitchCase;
import org.activebpel.rt.bpel.impl.activity.support.AeSwitchOtherwise;

/**
 * Visitor responsible for creating implementation objects from their definition
 * objects.<p>
 * 
 * A static convenience method called createProcess has been setup to easily 
 * create a new process implementation.
 */
public class AeDefToImplVisitor implements IAeDefVisitor
{
   /** Used in conjunction with the traversal object to traverse the object model */
   protected IAeDefVisitor mTraversalVisitor;
   /** The process id of the process we are creating an implemntation for. */
   protected long mProcessId;
   /** The engine the created process will run inside of. */
   protected IAeBusinessProcessEngineInternal mEngine;
   /** The process that we're creating implmentations for */
   protected AeBusinessProcess mProcess;
   /** Stores the stack of objects that we're visiting */
   protected Stack mStack = new Stack();
   /** Plan used to create the business process instance */
   protected IAeProcessPlan mPlan;
   
   /** 
    * Main entry point for implementation creation.
    * 
    * @param aPid The process Id to associate with the new process
    * @param aEngine The engine the process will run inside of.
    * @param aProcessDefinition The process definition we are visiting.
    * @return The new process implementation .
    */
   public static IAeBusinessProcess createProcess(long aPid,
                                                   IAeBusinessProcessEngineInternal aEngine, 
                                                   IAeProcessPlan aPlan)
   {
      AeDefToImplVisitor def2impl = new AeDefToImplVisitor(aPid, aEngine, aPlan);
      def2impl.startVisiting();
      return def2impl.getProcess();
   }
   
   /**
    * Ctor requires the process that you want to visit.
    * @param aPid the process id to create an implmentation for
    */
   public AeDefToImplVisitor(long aPid, IAeBusinessProcessEngineInternal aEngine, IAeProcessPlan aPlan)
   {
      mProcessId = aPid;
      mEngine = aEngine;
      mPlan = aPlan;
      init();
   }
   
   /**
    * Special constructor for sub classes 
    */
   protected AeDefToImplVisitor()
   {
   }

   /**
    * Creates the traversal and visitor object we're using to visit the object
    * model.
    */
   protected void init()
   {
      mTraversalVisitor = new AeTraversalVisitor(new AeImplementationTraverser(), this);
   }
   
   /**
    * Customized traverser that skips over the child scope for parallel forEach
    * activities. These definitions will be visited during the activity's execution
    * or during its state restoration. 
    */
   protected static class AeImplementationTraverser extends AeDefTraverser
   {
      /**
       * @see org.activebpel.rt.bpel.def.visitors.IAeDefTraverser#traverse(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef, org.activebpel.rt.bpel.def.visitors.IAeDefVisitor)
       */
      public void traverse(AeActivityForEachDef aDef, IAeDefVisitor aVisitor)
      {
         if (!aDef.isParallel())
         {
            super.traverse(aDef, aVisitor);
         }
         else
         {
            traverseSourceAndTargetLinks(aDef, aVisitor);
         }
      }
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeProcessDef)
    */
   public void visit(AeProcessDef aDef)
   {
      startVisiting();   
   }

   /**
    * Creates the process object and associates it with the current pid.  Then
    * traverses and creates all child implementations.
    */
   public void startVisiting()
   {
      AeBusinessProcess process = (AeBusinessProcess) mEngine.createProcess(mProcessId, mPlan);
      setProcess(process);
      traverse(mPlan.getProcessDef(), process);
   }

   /**
    * Creates the scope implementation and then traverses it.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityScopeDef)
    */
   public void visit(AeActivityScopeDef aDef)
   {
      AeActivityScopeImpl impl = new AeActivityScopeImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Pushes the implementation onto the stack so it'll become the parent for any
    * other activities created during the execution of this method. Then the
    * def is visited which may call back into this class with other visit methods.
    * Finally, we pop from the stack to restore the previous parent.
    * @param aDef
    * @param aImpl
    */
   protected void traverse(AeBaseDef aDef, Object aImpl)
   {
      // Add all BPEL objects to our lookup map
      if (aImpl instanceof IAeBpelObject)
         recordBpelObjectWithProcess(aDef, aImpl);
         
      // No need to bother with stack if we have no parent object   
      if (aImpl == null)
         aDef.accept(mTraversalVisitor);
      else
      {
         push(aImpl);
         aDef.accept(mTraversalVisitor);
         pop();
      }
   }

   /**
    * Records the existence of the bpel object with the process instance. This
    * is used for looking up objects by their location paths.
    * 
    * @param aDef
    * @param aImpl
    */
   protected void recordBpelObjectWithProcess(AeBaseDef aDef, Object aImpl)
   {
      getProcess().addBpelObject(aDef.getLocationPath(), (IAeBpelObject)aImpl);
   }

   /**
    * Pushes the activity onto the stack making it the current activity.
    * @param aActivity
    */
   protected void push(Object aObj)
   {
      mStack.push(aObj);
   }

   /**
    * Pops the activity from the stack.
    */
   protected void pop()
   {
      mStack.pop();
   }

   /**
    * Peeks at the current object on the stack.
    */
   protected Object peek()
   {
      return mStack.peek();
   }

   /**
    * Type safe peeker.
    */
   protected IAeActivityParent getActivityParent()
   {
      return (IAeActivityParent) peek();
   }

   /**
    * Type safe peeker.
    */
   protected AeActivityScopeImpl getScope()
   {
      return (AeActivityScopeImpl) peek();
   }

   /**
    * Type safe peeker.
    */
   protected IAeEventParent getMessageParent()
   {
      return (IAeEventParent) peek();
   }

   /**
    * Type safe peeker.
    */
   protected AeActivitySwitchImpl getSwitch()
   {
      return (AeActivitySwitchImpl) peek();
   }

   /**
    * Type safe peeker.
    */
   protected AeActivityFlowImpl getFlow()
   {
      return (AeActivityFlowImpl) peek();
   }
   
   /**
    * Type safe peeker.
    */
   protected AeActivityImpl getActivity()
   {
      return (AeActivityImpl) peek();
   }

   /**
    * Calls <code>accept</code> on the definition object. No need to create
    * an implementation object for the container here. 
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetContainerDef)
    */
   public void visit(AeCorrelationSetContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Create an event handler and add it to the scope. We then traverse in order
    * to pick up any messages or alarms. 
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeEventHandlersDef)
    */
   public void visit(AeEventHandlersDef aDef)
   {
      AeEventHandlersContainer events = new AeEventHandlersContainer(aDef, getScope());
      getScope().setEventHandlersContainer(events);
      traverse(aDef, events);
   }

   /**
    * Calls <code>accept</code> on the definition object. No need to create
    * an implementation object for the container here. The scope/process currently
    * on the stack will have the AeFaultHandlersDef objects added to it when
    * they get visited.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlersContainerDef)
    */
   public void visit(AeFaultHandlersContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Create the implementation object for the compensation handler container and
    * put it on the stack. The next activity visited will be added to the compensation
    * handler container.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeCompensatorContainerDef)
    */
   public void visit(AeScopeCompensatorContainerDef aDef)
   {
      AeCompensationHandler compHandler = new AeCompensationHandler(aDef, getScope());
      getScope().setCompensationHandler(compHandler);
      traverse(aDef, compHandler);
   }

   /**
    * Calls <code>accept</code> on the definition object. No need to create
    * an implementation object for the container here. The scope/process currently
    * on the stack will have the AeVariableDef objects added to it when
    * they get visited.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariablesContainerDef)
    */
   public void visit(AeVariablesContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Creates the assign implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityAssignDef)
    */
   public void visit(AeActivityAssignDef aDef)
   {
      AeActivityAssignImpl impl = new AeActivityAssignImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the compensate implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityCompensateDef)
    */
   public void visit(AeActivityCompensateDef aDef)
   {
      AeActivityCompensateImpl impl = new AeActivityCompensateImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the empty implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityEmptyDef)
    */
   public void visit(AeActivityEmptyDef aDef)
   {
      IAeActivity impl = new AeActivityEmptyImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the flow implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityFlowDef)
    */
   public void visit(AeActivityFlowDef aDef)
   {
      IAeActivity impl = new AeActivityFlowImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the invoke implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityInvokeDef)
    */
   public void visit(AeActivityInvokeDef aDef)
   {
      IAeActivity impl = new AeActivityInvokeImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the pick implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityPickDef)
    */
   public void visit(AeActivityPickDef aDef)
   {
      IAeActivity impl = new AeActivityPickImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the receive implmentation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReceiveDef)
    */
   public void visit(AeActivityReceiveDef aDef)
   {
      IAeActivity impl = new AeActivityReceiveImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the reply implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityReplyDef)
    */
   public void visit(AeActivityReplyDef aDef)
   {
      IAeActivity impl = new AeActivityReplyImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySuspendDef)
    */
   public void visit(AeActivitySuspendDef aDef)
   {
      IAeActivity impl = new AeActivitySuspendImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }
   
   /**
    * Creates the sequence implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySequenceDef)
    */
   public void visit(AeActivitySequenceDef aDef)
   {
      IAeActivity impl = new AeActivitySequenceImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the switch implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivitySwitchDef)
    */
   public void visit(AeActivitySwitchDef aDef)
   {
      IAeActivity impl = new AeActivitySwitchImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the terminate implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityTerminateDef)
    */
   public void visit(AeActivityTerminateDef aDef)
   {
      IAeActivity impl = new AeActivityTerminateImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the throw implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityThrowDef)
    */
   public void visit(AeActivityThrowDef aDef)
   {
      IAeActivity impl = new AeActivityThrowImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Creates the wait implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWaitDef)
    */
   public void visit(AeActivityWaitDef aDef)
   {
      IAeActivity impl = new AeActivityWaitImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef)
    */
   public void visit(AeActivityForEachDef aDef)
   {
      IAeActivity impl = aDef.isParallel() ? 
               new AeActivityForEachParallelImpl(aDef, getActivityParent()) : 
                  new AeActivityForEachImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachFinalDef)
    */
   public void visit(AeForEachFinalDef aDef)
   {
      // no impl for final expression
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachStartDef)
    */
   public void visit(AeForEachStartDef aDef)
   {
      // no impl for start expression
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachBranchesDef)
    */
   public void visit(AeForEachBranchesDef aDef)
   {
      // no impl for branches
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeForEachCompletionConditionDef)
    */
   public void visit(AeForEachCompletionConditionDef aDef)
   {
      // no impl for completion condition
   }
   
   /**
    * Creates the <code>while</code> implementation and traverses.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityWhileDef)
    */
   public void visit(AeActivityWhileDef aDef)
   {
      IAeActivity impl = new AeActivityWhileImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityContinueDef)
    */
   public void visit(AeActivityContinueDef aDef)
   {
      IAeActivity impl = new AeActivityContinueImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityBreakDef)
    */
   public void visit(AeActivityBreakDef aDef)
   {
      IAeActivity impl = new AeActivityBreakImpl(aDef, getActivityParent());
      getActivityParent().addActivity(impl);
      traverse(aDef, impl);
   }

   /**
    * Create the correlation set implementation object and add it to the scope.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationSetDef)
    */
   public void visit(AeCorrelationSetDef aDef)
   {
      AeCorrelationSet set = new AeCorrelationSet(aDef, getScope());
      getScope().addCorrelationSet(set);
      traverse(aDef, set);
   }

   /**
    * Create instance of fault handler implementation and add to the current scope's
    * fault handler container. Then traverse the def object so we'll add the 
    * child activity to the fault.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeFaultHandlerDef)
    */
   public void visit(AeFaultHandlerDef aDef)
   {
      AeFaultHandler fh = new AeFaultHandler(aDef, getScope());
      getScope().addFaultHandler(fh);
      traverse(aDef, fh);
   }

   /**
    * Create instance of alarm and add to the current parent which is either
    * a pick or an event handler for a scope.
    * 
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnAlarmDef)
    */
   public void visit(AeOnAlarmDef aDef)
   {
      AeOnAlarm alarm = new AeOnAlarm(aDef, getMessageParent());
      getMessageParent().addAlarm(alarm);
      traverse(aDef, alarm);
   }

   /**
    * Create instance of message and add to the current parent which is either
    * a pick or an event handler for a scope.
   
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOnMessageDef)
    */
   public void visit(AeOnMessageDef aDef)
   {
      AeOnMessage msg = new AeOnMessage(aDef, getMessageParent());
      getMessageParent().addMessage(msg);
      traverse(aDef, msg);
   }

   /**
    * Create instance of variable and add to scope.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeVariableDef)
    */
   public void visit(AeVariableDef aDef)
   {
      AeVariable var = new AeVariable(getScope(), aDef);
      getScope().addVariable(var);
      recordVariableWithProcess(var);
      traverse(aDef, var);
   }

   /**
    * Records the existence of the variable with the process, mapping the variable's
    * location path to the instance.
    * @param aVar
    */
   protected void recordVariableWithProcess(AeVariable aVar)
   {
      getProcess().addVariableMapping(aVar.getLocationPath(), aVar);
   }

   /**
    * Create instance of <code>catchAll</code> and add to scope.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeDefaultFaultHandlerDef)
    */
   public void visit(AeDefaultFaultHandlerDef aDef)
   {
      AeDefaultFaultHandler catchAll = new AeDefaultFaultHandler(aDef, getScope());
      getScope().setDefaultFaultHandler(catchAll);
      traverse(aDef, catchAll);
   }

   /**
    * Create instance of <code>case</code> and add to <code>switch</code> that's
    * currently on the stack.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef)
    */
   public void visit(AeSwitchCaseDef aDef)
   {
      AeSwitchCase caze = new AeSwitchCase(aDef, getSwitch());
      getSwitch().addCase(caze);
      traverse(aDef, caze);
   }

   /**
    * The <code>assign</code> implementation will handle its copy, from, and to so
    * there is nothing to create or traverse here. 
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignCopyDef)
    */
   public void visit(AeAssignCopyDef aDef)
   {
      // no-op
   }

   /**
    * No implementation to create or traverse.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeCorrelationDef)
    */
   public void visit(AeCorrelationDef aDef)
   {
      // no-op
   }

   /**
    * Create a link implementation and add it to the current flow. No further traversal.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkDef)
    */
   public void visit(AeLinkDef aDef)
   {
      AeLink link = new AeLink(aDef, getFlow());
      getFlow().addLink(link);
   }

   /**
    * No implementation or further traversal.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerDef)
    */
   public void visit(AePartnerDef aDef)
   {
      // no-op
   }

   /**
    * Create the <code>partnerLink</code> impl and add to the process.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinkDef)
    */
   public void visit(AePartnerLinkDef aDef)
   {
      getProcess().addPartnerLink(new AePartnerLink(aDef));
   }

   /**
    * Nothing to create for scope def, just traverse to visit all of its children.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeScopeDef)
    */
   public void visit(AeScopeDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeMessageExchangesDef)
    */
   public void visit(AeMessageExchangesDef aDef)
   {
      // nothing to create here and no children that need traversing
   }
   
   /**
    * Find the <code>link</code> that this <code>source</code> references and
    * add it to the <code>AeActivityImpl</code>'s collection of source links.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSourceDef)
    */
   public void visit(AeSourceDef aDef)
   {
      AeLink link = findLink(aDef.getLinkName());
      link.setTransitionCondition(aDef.getTransitionCondition());
      link.setSourceActivity(getActivity());
      getActivity().addSourceLink(link);      
   }

   /**
    * Find the <code>link</code> that this <code>target</code> references and
    * add it to the <code>AeActivityImpl</code>'s collection of target links.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeTargetDef)
    */
   public void visit(AeTargetDef aDef)
   {
      AeLink link = findLink(aDef.getLinkName());
      link.setTargetActivity(getActivity());
      getActivity().addTargetLink(link);      
   }

   /**
    * Nothing to create directly, instead just visit the container so we'll hit
    * the <code>partnerLink</code>s individually.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnerLinksContainerDef)
    */
   public void visit(AePartnerLinksContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Nothing to create or traverse here.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AePartnersContainerDef)
    */
   public void visit(AePartnersContainerDef aDef)
   {
   }

   /**
    * Nothing to create but we need to traverse so we'll hit the links.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeLinkContainerDef)
    */
   public void visit(AeLinkContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Create the <code>otherwise</code> and add it to the <code>switch</code>
    * that's on the stack. 
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeOtherwiseDef)
    */
   public void visit(AeOtherwiseDef aDef)
   {
      AeSwitchOtherwise otherwise = new AeSwitchOtherwise(aDef, getSwitch());
      getSwitch().setOtherwise(otherwise);
      traverse(aDef, otherwise);
   }

   /**
    * Nothing to create, just traverse here.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeCorrelationContainerDef)
    */
   public void visit(AeCorrelationContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * Nothing to create, just traverse here so we'll hit the individual <code>case</code>s.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseContainerDef)
    */
   public void visit(AeSwitchCaseContainerDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportsContainerDef)
    */
   public void visit(AeImportsContainerDef aDef)
   {
      // Do not visit. BPEL v1.1 does not support imports
   }

   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.AeImportDef)
    */
   public void visit(AeImportDef aDef)
   {
      // Do not visit. BPEL v1.1 does not support imports
   }

   /**
    * The <code>assign</code> implementation will handle it's copy, from, and to. 
    * Nothing to do here but we'll traverse for the sake of traversing.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignFromDef)
    */
   public void visit(AeAssignFromDef aDef)
   {
      traverse(aDef, null);
   }

   /**
    * The <code>assign</code> implementation will handle it's copy, from, and to. 
    * Nothing to do here but we'll traverse for the sake of traversing.
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.support.AeAssignToDef)
    */
   public void visit(AeAssignToDef aDef)
   {
      traverse(aDef, null);
   }

   protected void setProcess(AeBusinessProcess aProcess)
   {
      mProcess = aProcess;
   }

   public AeBusinessProcess getProcess()
   {
      return mProcess;
   }

   /**
    * Searches the stack for a flow starting from length - 2.
    * @param aDef
    */
   private AeLink findLink(String aLinkName)
   {
      for (int i=mStack.size()-2; i>0; i--)
      {
         Object potentialLink = mStack.get(i);
         if (potentialLink instanceof AeActivityFlowImpl)
         {
            AeActivityFlowImpl flow = (AeActivityFlowImpl) potentialLink;
            AeLink link = flow.getLink(aLinkName);
            if (link != null)
            {
               return link;
            }
         }
      }
      // not finding one should be a fatal error.
      throw new RuntimeException(AeMessages.getString("AeDefToImplVisitor.ERROR_0")+aLinkName); //$NON-NLS-1$
   }
}
