//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/def/visitors/AeImplicitVariableVisitor.java,v 1.2 2006/01/19 21:17:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.def.visitors; 

import javax.xml.namespace.QName;

import org.activebpel.rt.bpel.def.AeVariableDef;
import org.activebpel.rt.bpel.def.IAeBPELConstants;
import org.activebpel.rt.bpel.def.activity.AeActivityForEachDef;

/**
 * A visitor responsible for creating implicit variables on def objects. 
 */
public class AeImplicitVariableVisitor extends AeAbstractDefVisitor
{
   public AeImplicitVariableVisitor()
   {
      setTraversalVisitor( new AeTraversalVisitor( new AeDefTraverser(), this ) );
   }
   
   /**
    * @see org.activebpel.rt.bpel.def.visitors.IAeDefVisitor#visit(org.activebpel.rt.bpel.def.activity.AeActivityForEachDef)
    */
   public void visit(AeActivityForEachDef aDef)
   {
      String counterName = aDef.getCounterName();
      if(aDef.getChildScope() != null)
      {
         AeVariableDef varDef = aDef.getChildScope().getScope().getVariable(counterName);
         if (varDef != null)
         {
            varDef.setMessageType(null);
            varDef.setElement(null);
         }
         else
         {
            varDef = new AeVariableDef();
            varDef.setName(counterName);
            aDef.getChildScope().getScope().addVariable(varDef);
         }
         varDef.setType(new QName(IAeBPELConstants.W3C_XML_SCHEMA, "unsignedInt")); //$NON-NLS-1$
         varDef.setImplicit(true);
      }
      
      super.visit(aDef);
   }
}
 
