//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/AeReplyReceiverAdapter.java,v 1.1 2005/06/28 22:53:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl;

import java.util.Map;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.IAeFault;
import org.activebpel.rt.message.IAeMessageData;

/**
 * Adapter for constructing an <code>IAeReplyReceiver</code> from an
 * <code>IAeMessageReceiver</code>.
 */
public class AeReplyReceiverAdapter implements IAeReplyReceiver
{
   /** The delegate <code>IAeMessageReceiver</code> object. */
   private IAeMessageReceiver mDelegate;
   
   /**
    * Constructor.
    * @param aReceiver
    */
   public AeReplyReceiverAdapter( IAeMessageReceiver aReceiver )
   {
      mDelegate = aReceiver;
   }

   /**
    * @see org.activebpel.rt.bpel.impl.IAeReplyReceiver#onFault(org.activebpel.rt.bpel.IAeFault, java.util.Map)
    */
   public void onFault(IAeFault aFault, Map aProcessProperties)
         throws AeBusinessProcessException
   {
      getDelegate().onFault( aFault );
   }

   /**
    * @see org.activebpel.rt.bpel.impl.IAeReplyReceiver#onMessage(org.activebpel.rt.message.IAeMessageData, java.util.Map)
    */
   public void onMessage(IAeMessageData aMessage, Map aProcessProperties)
         throws AeBusinessProcessException
   {
      getDelegate().onMessage( aMessage );
   }
   
   /**
    * @return Returns the delegate.
    */
   protected IAeMessageReceiver getDelegate()
   {
      return mDelegate;
   }
}
