//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/IAeEnginePartnerLinkStrategy.java,v 1.1 2005/07/12 00:19:4
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.IAeBusinessProcess;
import org.activebpel.rt.bpel.impl.queue.AeInboundReceive;

/**
 * Defines an interface for how a business process engine should manage
 * partner links.
 */
public interface IAeEnginePartnerLinkStrategy
{
   /**
    * Initializes the partner links for the business process.
    * 
    * @param aProcess the process to initialize partner links for
    * @param aDesc the plan describing the partner link initialization
    */
   public void initPartnerLinks(IAeBusinessProcess aProcess, IAeProcessPlan aDesc) throws AeBusinessProcessException;

   /**
    * Updates the partner link object with the data from the inbound receive.
    *
    * @param aProcess
    * @param aInboundReceive
    */
   public void updatePartnerLink(IAeBusinessProcess aProcess, AeInboundReceive aInboundReceive) throws AeBusinessProcessException;
}
