// $Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/activity/support/AeSwitchCase.java,v 1.11 2005/12/03 01:01:1
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl.activity.support;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.IAeProcessInfoEvent;
import org.activebpel.rt.bpel.def.activity.support.AeSwitchCaseDef;
import org.activebpel.rt.bpel.impl.activity.AeActivitySwitchImpl;
import org.activebpel.rt.bpel.impl.visitors.IAeImplVisitor;

/**
 * Models the <code>case</code> and <code>otherwise</code> in a 
 * <code>switch</code>
 */
public class AeSwitchCase extends AeSwitchOtherwise
{
   /**
    * Ctor for creating a <code>case</code> implementation.
    * @param aDef
    * @param aParent
    */
   public AeSwitchCase(AeSwitchCaseDef aDef, AeActivitySwitchImpl aParent)
   {
      super(aDef, aParent);
   }

   /** 
    * Overrides method to 
    * @see org.activebpel.rt.bpel.impl.visitors.IAeVisitable#accept(org.activebpel.rt.bpel.impl.visitors.IAeImplVisitor)
    */
   public void accept( IAeImplVisitor aVisitor ) throws AeBusinessProcessException
   {
      aVisitor.visit(this);
   }   
   
   /**
    * Returns true if our expression evaluates to true. Always true for otherwise.
    */
   public boolean isEvalTrue() throws AeBusinessProcessException
   {
      AeSwitchCaseDef def = (AeSwitchCaseDef)getDefinition();
      boolean result = executeBooleanExpression(def.getCondition());
       
      // Generate engine info event for debug.
      getProcess().getEngine().fireEvaluationEvent( 
         getProcess().getProcessId(), def.getCondition(), this, IAeProcessInfoEvent.INFO_CASE, getLocationPath(), Boolean.toString(result));

      return result ;
   }
}
