//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/expr/xpath/AeXPathExpressionTypeConverter.java,v 1.1 2005/06/08 12:50:3
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl.expr.xpath;

import org.activebpel.rt.bpel.impl.expr.AeExpressionTypeConverter;

/**
 * An implementation of a type converter for jaxen.  This class is necessary because Jaxen doesn't like
 * certain Java types.  So we convert those types to other types that Jaxen DOES like.
 */
public class AeXPathExpressionTypeConverter extends AeExpressionTypeConverter
{
   /**
    * Overrides method to do some extra conversions needed by Jaxen.
    * 
    * @see org.activebpel.rt.bpel.impl.expr.AeExpressionTypeConverter#convert(java.lang.Object)
    */
   public Object convert(Object aType)
   {
      Object type = super.convert(aType);
      if (type instanceof Number)
      {
         // jaxen likes doubles, but not floats, big integers, so convert to double here
         type = new Double(((Number) aType).doubleValue());
      }
      return type;
   }
}
