//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/function/AeAbstractBpelFunction.java,v 1.2 2005/12/08 17:19:0
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl.function;

import javax.xml.namespace.QName;

import org.activebpel.rt.bpel.AeBusinessProcessException;
import org.activebpel.rt.bpel.AeMessages;
import org.activebpel.rt.bpel.IAeVariable;
import org.activebpel.rt.bpel.function.IAeFunction;
import org.activebpel.rt.bpel.impl.AeAbstractBpelObject;
import org.activebpel.rt.wsdl.def.IAePropertyAlias;

/**
 * Base class for standard <code>IAeFunction</code> impls.
 */
public abstract class AeAbstractBpelFunction implements IAeFunction
{
   /**
    * Constructor.
    */
   protected AeAbstractBpelFunction()
   {
   }

   /**
    * Get externalized string.
    * @param aKey
    */
   protected static String getExternalizedString( String aKey )
   {
      return AeMessages.getString( aKey );
   }
   
   /**
    * Delegates the call to the parent.
    * 
    * @see org.activebpel.rt.bpel.impl.IAeBpelObject#getVariable(java.lang.String)
    */
   public IAeVariable getVariable(AeAbstractBpelObject aBpelObj, String aName)
   {
      return aBpelObj.getParent().getVariable(aName);
   }
   
   /**
    * Gets the message property from the wsdl 
    * @param aName
    * @param propName
    */
   protected IAePropertyAlias getMessageProperty(AeAbstractBpelObject aBpelObj, QName aName, QName aPropName) throws AeBusinessProcessException
   {
      return aBpelObj.getProcess().getMessageProperty(aName, aPropName);
   }
   
   /**
    * Return true if <code>IAeMutableConfig</code> settings for engine
    * allow empty query selection.
    */
   protected boolean isSelectionFailureDisabled(AeAbstractBpelObject aBpelObj)
   {
      return aBpelObj.getProcess().getEngine().getEngineConfiguration().getUpdatableEngineConfig().allowEmptyQuerySelection();
   }

}
