//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/function/AeExtensionFunctionContext.java,v 1.2 2006/01/10 22:18:2
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl.function;

import org.activebpel.rt.bpel.function.AeUnresolvableException;
import org.activebpel.rt.bpel.function.IAeFunction;

/**
 * A <code>FunctionContext</code> implementation that handles returning
 * BPEL extension functions.
 * 
 * Currently supported function are:
 * <pre>getProcessId</pre> 
 */
public class AeExtensionFunctionContext extends AeAbstractFunctionContext
{
   // Constant for getProcessId bpel extension function. */
   public static final String PROCESS_ID  = "getProcessId"; //$NON-NLS-1$
   // Constant for getMyRoleProperty bpel function. */
   public static final String GET_MYROLE_PROPERTY = "getMyRoleProperty"; //$NON-NLS-1$
   

   /**
    * @see org.activebpel.rt.bpel.function.IAeFunctionContext#getFunction(java.lang.String)
    */
   public IAeFunction getFunction(String aLocalName) throws AeUnresolvableException
   {
      if (PROCESS_ID.equals(aLocalName))
      {
         return new AeGetProcessIdFunction();
      }
      else if (GET_MYROLE_PROPERTY.equals(aLocalName))
      {
         return new AeGetMyRolePropertyFunction();
      }
      else
      {
         throw new AeUnresolvableException(formatFunctionNotFoundErrorMsg(aLocalName));
      }
   }
}
