//$Header: /Development/AEDevelopment/projects/org.activebpel.rt.bpel/src/org/activebpel/rt/bpel/impl/list/AeWsdlListingDetail.java,v 1.1 2004/11/23 00:04:0
/*
 * Copyright (c) 2004-2006 Active Endpoints, Inc.
 *
 * This program is licensed under the terms of the GNU General Public License
 * Version 2 (the "License") as published by the Free Software Foundation, and 
 * the ActiveBPEL Licensing Policies (the "Policies").  A copy of the License 
 * and the Policies were distributed with this program.  
 *
 * The License is available at:
 * http: *www.gnu.org/copyleft/gpl.html
 *
 * The Policies are available at:
 * http: *www.activebpel.org/licensing/index.html
 *
 * Unless required by applicable law or agreed to in writing, this program is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
 * OF ANY KIND, either express or implied.  See the License and the Policies
 * for specific language governing the use of this program.
 */
package org.activebpel.rt.bpel.impl.list;

/**
 * Detail for displaying listing of wsdl.
 */
public class AeWsdlListingDetail
{
    /** The wsdl's location. */
    protected String mLocation;
    /** The wsdl's namespace. */
    protected String mNamespace;

    /**
     * Default constructor.
     */
    public AeWsdlListingDetail(String aLocation, String aNamespace)
    {
       mLocation = aLocation;
       mNamespace = aNamespace;
    }

    /**
     * Getter for the location.
     */
    public String getLocation()
    {
       return mLocation;
    }
    
    /**
     * Setter for the location.
     * 
     * @param aLocation
     */
    public void setLocation(String aLocation)
    {
       mLocation = aLocation;
    }
    
    /**
     * Return the short name of the wsdl file.
     * Strips off any preceeding path information from the location.
     */
    public String getFormattedWsdlName()
    {
        String location = mLocation.replace('\\', '/');
        if( location.indexOf('/') != -1 )
        {
            return location.substring( location.lastIndexOf('/')+1 );
        }
        else
        {
            return location;
        }
    }
    
    /**
     * Getter for the namespace.
     */
    public String getNamespace()
    {
       return mNamespace;
    }
    
    /**
     * Setter for the namespace.
     * 
     * @param aNamespace
     */
    public void setNamespace(String aNamespace)
    {
       mNamespace = aNamespace;
    }
}
